;SX_Key

CPU_LONG_DATE

;CPUPINS_18
CPUPINS_28
;CPUPINS_48
;CPUPINS_52

IFDEF SX_Key 					;SX-Key Directives

  IFDEF CPUPINS_18					;SX28AC device directives for SX-Key		
    IFDEF CPU_LONG_DATE
	device	SX18L,oschs2,turbo,stackx_optionx
    ELSE
	device	pins18, pages4, banks8, turbo, stackx, optionx
      ENDIF
	CpuPins = 18
    ENDIF

  IFDEF CPUPINS_28					;SX28AC device directives for SX-Key		
    IFDEF CPU_LONG_DATE
	device	SX28L,oschs2,turbo,stackx_optionx
    ELSE
	device	pins28, pages4, banks8, turbo, stackx, optionx
      ENDIF
	CpuPins = 28
    ENDIF

  IFDEF CPUPINS_48					;SX48/52/BD device directives for SX-Key
    IFDEF CPU_LONG_DATE
	device	oschs2
    ELSE
	device 	DRTOFF, TURBO, STACKX, OPTIONX
      ENDIF
	CpuPins = 48
    ENDIF

  IFDEF CPUPINS_52					;SX48/52/BD device directives for SX-Key
    IFDEF CPU_LONG_DATE
	device	oschs2
    ELSE
	device 	DRTOFF, TURBO, STACKX, OPTIONX
      ENDIF
	CpuPins = 52
    ENDIF

ELSE	  					;SASM Directives
  IFDEF CPUPINS_28				;SX28AC device directives for SASM
	device	SX28,oschs2,turbo,stackx,optionx
	CpuPins = 28
    ENDIF
  
  IFDEF CPUPINS_48					;SX48BD or SX52BD device directives for SASM
	device	SX52,oschs2  
	CpuPins = 48
    ENDIF

  IFDEF CPUPINS_52					;SX48BD or SX52BD device directives for SASM
	device	SX52,oschs2  
	CpuPins = 52
    ENDIF
  ENDIF

IFDEF CPU_LONG_DATE
	CpuLongDate = 1	;=0 for old 4 digit date code, =1 for new "A" 8 digit date code
ELSE
	CpuLongDate = 0
  ENDIF


CpuMhz 	EQU 50
CpuMode 	EQU 	0	;=0 for debug, =1 for full speed
CpuCarry 	EQU 	1	;carryx is on.
DebugMemSpi	EQU	0	;=3 data port bits, =2 bit, =1 byte, =0 none
DebugPP	EQU	0	;=2 for status =1 for data debug, =0 for normal
DebugPC	EQU	0	;=2 for status =1 for data debug, =0 for normal
DebugVM	EQU	2

 IFDEF CpuCarry
		device carryx
  ENDIF


IF CpuMode = 1
 IF CpuLongDate = 1
		device	OSCXTMAX
 ELSE
		device	oschs			;full speed operation
  ENDIF
ELSE
		device	oscrc			;debug operation
 ENDIF

IF CpuMhz = 50
		freq	50_000_000
ENDIF
IF CpuMhz = 100
		freq	100_000_000
ENDIF

IF CpuPins > 18
 IF CpuPins > 28
GPRegOrg	=	$0A	;$0A to $0F - limited to 6 bytes - global
 ELSE
GPRegOrg	=	8	;$08 to $0F - limited to 8 bytes - global
 ENDIF
ELSE
GPRegOrg	=	7	;$07 to $0F - limited to 9 bytes - global
ENDIF

		id	'PRNPLUGC'

IF CpuPins = 18 
		error 'this application requires at least 28 pins'
ENDIF

		reset	reset_entry

;EQUATES *************************************************************************


OptRTCisW	=	%01111111	;And with Opts to make register 1 show W
OptRTCEnable	=	%10111111	;And with Opts to enable rtcc interrupt
OptRTCInternal	=	%11011111	;And with Opts to make rtcc internal
OptRTCIntLead	=	%11101111	;And with Opts to make rtcc inc on Leading edge
OptRTCPrescale	=	%11110111	;And with Opts to enable rtcc prescaler
Opts		=	%11111000	;base Options. Last 3 bits are the PreScale divider.

IF CpuMhz = 100	
OptPreScale 	= 	8
IntPeriod	=	217		;will be subtracted from 256 to inc RTCC
myOpts		=	Opts & OptRTCEnable & OptRTCInternal & OptRTCisW
ENDIF

IF CpuMhz = 75	
OptPreScale 	= 	8
IntPeriod	=	244		;will be subtracted from 256 to inc RTCC
myOpts		=	Opts & OptRTCEnable & OptRTCInternal & OptRTCisW
ENDIF

IF CpuMhz = 50	
OptPreScale	= 	4
IntPeriod	=	217		;will be subtracted from 256 to inc RTCC
myOpts		=	Opts & OptRTCEnable & OptRTCInternal & OptRTCisW
ENDIF
;217 is a magic number that "just works" at 50 or 100Mhz for RS232 irrespective 
;of the Pre Scale. See
;http://www.sxlist.com/techref/scenix/isrcalc.asp 
;to calculate other options
;217*4=868 cycles per interrupt. PP at .5us strobe via delay loops
;57,604 Hz interrupt rate 0.000,017,36 seconds per interrupt


;PreScaleBits 000=1:2, 001=1:4, 010=1:8, 011=1:16, 100=1:32, 101=1:64, 110=1:128, 111=1:256
OptPreScaleBits = ((OptPreScale>3)&1) 
OptPreScaleBits = OptPreScaleBits + ((OptPreScale>7)&1) + ((OptPreScale>15)&1) + ((OptPreScale>31)&1) + ((OptPreScale>63)&1) + ((OptPreScale>127)&1) + ((OptPreScale>255)&1)
IF OptPreScale > 1
	IF OptPreScale = (2 << OptPreScaleBits)	;Just incase an invalid PreScale was selected
myOpts		=	myOpts & OptRTCPrescale | OptPreScaleBits
	ELSE
	ERROR 'invalid Prescale value'
		ENDIF
ELSE
myOpts		= 	myOpts | (255^OptRTCPreScale)

	ENDIF

ISRRate = 0
IF myOpts & OptRTCEnable AND myOpts & OptRTCInternal
	MaxISRCycles = OptPreScale * IntPeriod
	ISRRate = cpuMHz*1000000 / MaxISRCycles
	ENDIF

; The following three values determine the UART baud rate.
;  Baud rate = cpuMHz/(RS232ISRDiv * MaxISRCycles)
;            = cpuMHz/(RS232ISRDiv * OptPreScale * IntPeriod)
;
RS232BaudRate	=	9600
RS232ISRDiv 	= 	ISRRate / RS232BaudRate
IF RS232ISRDiv < 1 or RS232ISRDiv > 255
	ERROR 'RS232BaudRate incompatible with cpuMhz and OptPreScale'
	ENDIF
; The start delay value must be set equal to RS232ISRDiv * 1.5 + 1
RS232StartDelay	=	RS232ISRDiv + (RS232ISRDiv>>1) + 1

HighHalfPage = $100


WKPND_B		=	$09
WKED_B		=	$0A
WKEN_B		=	$0B

;VM Equates --------------------------------------------------------------
BufTyp0	= 0	;RAM Registers
BufTypF	= 1	;FLASH Memory (Mem:Read or Mem:Write)
BufTypP	= 2	;Parallel Port (Peripheral (Perp) or Host)
BufTypQ	= 3	;Que (Push or Pop)
BufTypR	= 4	;ROM (Program Memory IREAD or IWRITE if we had a bootloader)
BufTypS	= 5	;Serial (RS232In or RS232Out)
BufTypT	= 6	;Terminal 

;MACROS --------------------------------------------------------------------------

in	EQU	$F00
out	EQU	$FFF
pull	EQU	$E00
float	EQU	$EFF
cmos	EQU	$D00
ttl	EQU	$DFF
sch	EQU	$CFF
inten	EQU	$B00
intedge	EQU	$A00
intpend EQU	$900

porthelp MACRO
	ERROR 'USAGE: port r[a,b,c,d,e] [in,out,pull,float,cmos,ttl] bits'
	ENDM

_PortMode = $1F

PortMode MACRO 1
	noexpand
; IF aPortMode <> \1
IF CpuPins > 28
  expand
 mov w,#(\1 | $10)
 mov m,w
  noexpand
ELSE
  expand
 mov	m,#\1
  noexpand
ENDIF
;  ENDIF
 ENDM

port	MACRO	3
	noexpand
IF \1=RA OR \1=RB OR (CpuPins>18 AND \1=RC) OR (CpuPins > 28 AND (\1=RD OR \1=RE))
ELSE
;	porthelp
  ENDIF
IF \2=in OR \2=out OR \2=pull OR \2=float OR \2=cmos OR \2=ttl OR (\1=RB AND (\2=sch OR \2=inten OR \2=intedge OR \2=intpend))
ELSE
;	porthelp
  ENDIF
	PortMode (\2 / $100) 
	expand
 mov !\1, #(\2//$100)^\3
	noexpand
	ENDM

tst	= %11111
tst	= (tst & %00001) + ((tst & %00010)>>1)  + ((tst & %00100)>>2) + ((tst & %01000)>>3) + ((tst & %10000)>>4)

CtrlAssert	MACRO	1
 IF (CtrlA2 / $100) = 4 AND (CtrlnE / $100) = 5 
  expand
 mov w, #\1 | (1 << (CtrlnE // $100))
 setb CtrlnE
 mov CtrlPort, w
 mov StatusPort, w
 clrb CtrlnE
  noexpand
 ELSE
  expand
 mov w, #\1
  noexpand
  IF \1 & CtrlExt
   CtrlAssertExtW
  ELSE
   CtrlAssertIntW
   ENDIF
  ENDIF
 IF (\1 & 1)=0 
  expand
 clrb (CtrlStatus + 0).(\1>>2) ;D0=0
  noexpand
 ELSE
  expand
 setb (CtrlStatus + 0).(\1>>2) ;D0=1
  noexpand
  ENDIF
 IF (\1 & 2 >> 1)=0 
  expand
 clrb (CtrlStatus + 1).(\1>>2) ;D1=0
  noexpand
 ELSE
  expand
 setb (CtrlStatus + 1).(\1>>2) ;D1=1
  noexpand
  ENDIF
 ENDM

CtrlAssertIntW	MACRO 0
 noexpand
;take a value in W containing data and address information for the 
;Control Port and use CtrlPortW to safely set that value, then
;set up the external select and re-enable the port.
 CtrlPortW
 expand
 clrb CtrlA2 ;address internal devices
 clrb CtrlnE ;enable (active low) the new value 
 noexpand
 ENDM

CtrlAssertExtW	MACRO 0
 noexpand
;take a value in W containing data and address information for the 
;Control Port and use CtrlPortW to safely set that value, then
;set up the internal select and re-enable the port.
 CtrlPortW
 expand
 setb CtrlA2 ;address external devices
 clrb CtrlnE ;enable (active low) the new value
 noexpand
 ENDM

CtrlPortW	MACRO 0
 noexpand
;take a value in W containing data and address information for the 
;Control Port and safely set the control port to that value.
;The Not Enable line must be set high, then, assuming the values in W
;allign with the lines on the control port, W can be copied to the port.
 expand
 setb CtrlnE ;disable (active low) the latches
 mov CtrlPort,w ;new value to port
 noexpand
 ENDM

;	org 700
;	CtrlAssert HostData
;	CtrlAssert HostPStrobe


mynop	MACRO
	noexpand
	page $
	ENDM

nsec	EQU	-9
usec	EQU	-6
msec	EQU	-3
sec	EQU	1
cycles	EQU	0


cyclefor MACRO 1
	noexpand
_cycles = \1
_temp = 0
IF _cycles - 10 > IntPeriod OR _cycles < 0
 _cycles = _cycles - 10
 _ints3 = $FF - (_cycles/(IntPeriod*$10000))
 _ints2 = $FF - (_cycles/(IntPeriod*$100)//$100)
 _ints1 = $FF - (_cycles/IntPeriod//$100)
IF Timers > $0F
;	ERROR 'Timers must be in bank 0'
	bank Timers
ENDIF
	expand
	clr	TimerAccL
	mov	TimerAccT, #_ints3
	mov	TimerAccH, #_ints2
	mov	TimerAccL, #_ints1
	mov	w,#$02
	clrb	TimerFlag
	sb	TimerFlag
	sub	2,w
	noexpand
 _cycles = _cycles // IntPeriod

ELSE
_temp = $ // 4

IF _temp = 2
 IF _cycles < 5 
  REPT	_cycles
	expand
	 mynop
	noexpand
  ENDR
_cycles = 0
 ELSE
	expand
	 mynop
	noexpand
_cycles = _cycles -1
  ENDIF
 ENDIF
IF _temp = 1
 IF _cycles < 7 
  REPT	_cycles
	expand
	 mynop
	noexpand
   ENDR
_cycles = 0
 ELSE
_cycles = _cycles - 2
_loops = _cycles / 5
	expand
	 mov w, #_loops
	 page $+1
	 decsz 1
	 jmp $-1
	noexpand
 _cycles = _cycles // 5 ;cycles left over
  ENDIF
 ENDIF
IF _cycles > 5
_cycles = _cycles - 1
_loops = _cycles / 5
	expand
	 mov w, #_loops
	 decsz 1
	 clrb 2.1
	noexpand
 _cycles = _cycles // 5 ;cycles left over
 ENDIF
IF _cycles > 0
  REPT	_cycles
	expand
	 mynop
	noexpand
   ENDR
 ENDIF
ENDIF
	ENDM

delayhelp MACRO
	ERROR 'USAGE: delay value, [usec,msec,sec,cycles]'
	ENDM

delay	MACRO	2
noexpand
;Calculates cycles from delay value and units (milli seconds, micro seconds, or seconds)
;calls cyclefor to delay that number of cycles

;IF ( ( ( \2 = -9 ) OR ( \2 = -6 ) OR ( \2 = -3 ) OR ( \2 = 1 ) ) AND ( ( \1 < 1000 ) AND ( \1 > 0 ) ) )

 IF \2 = 1 
  _cycles = (\1 * 100000000 / (100/CpuMhz))
  ENDIF
 IF \2=msec
  _cycles = (\1 * 1000000 / (1000/CpuMhz))
  ENDIF
 IF \2=usec
  _cycles = (\1 * 1000 / (1000/CpuMhz))
  ENDIF
 IF \2=nsec
  _cycles = (\1 * 10 + 5 / (10000/CpuMhz))
  ENDIF
 IF \2=cycles
  _cycles = \1
  ENDIF
 IF _cycles = 0
  expand
	 ;delay less than one cycle at this processor speed'
  noexpand
 ELSE
  cyclefor _cycles
  ENDIF

;ELSE
;	delayhelp
;ENDIF
	ENDM

ConditionBase equ $0
IsZero	equ	ConditionBase + %0000
Eq	equ	ConditionBase + %0001
Lt	equ	ConditionBase + %0010 ;2
LE	equ	ConditionBase + %0011 ;3
IsNotZero equ	ConditionBase + %0100 ;8
NE	equ	ConditionBase + %0101 ;9
GE	equ	ConditionBase + %0110 ;10
Gt	equ	ConditionBase + %0111 ;11
EqN	equ	ConditionBase + %1001
LtN	equ	ConditionBase + %1010 ;2
LEN	equ	ConditionBase + %1011 ;3
NEN	equ	ConditionBase + %1101 ;9
GEN	equ	ConditionBase + %1110 ;10
GtN	equ	ConditionBase + %1111 ;11
;                                dabc
SkMskConst	equ	%1000
;column "d" (mask 8) shows which compare registers with constants and which with registers.
SkMskSwap	equ	%0100
;column "a" (mask 4) shows which are exact opposites of one another.
; e.g. Eq is the opposite of NE, Lt of GE, LE of Gt
SkMskNeq	equ	%0010
;column "b" (mask 2) shows which are inequalities and which are equalitites
SkMskC		equ	%0001
;column "c" (mask 1) differentiates the inequalities
SkMskFlip	equ	%0101
;Xor with condition to flip the inequality around X op Y becomes Y op X


Skc MACRO 3
;	noexpand
;Usage: Skc pX, Condition, pY
 pX = \1
 tst = \2
 pY = \3
 SkcBank = 0

 IF tst & SkMskConst
  IF pX = WReg AND ((tst & SkMskNeq) > 1)
	expand
 mov temp, w	;WARNING! temp modified in macro.
	noexpand
   pX = temp
   ENDIF
  IF tst = GtN OR tst = LEN
	expand
 mov w, #(pY + 1)
	noexpand
   ;if tst was GtN its now GE if it was LEN its Lt
   tst = (tst ^ SkMskC) & ~SkMskConst
  ELSE ; tst = GEN, LtN, NEN, EqN
   IF pX = WReg
    pX = pY
   ELSE
	expand
 mov w, #pY
	noexpand
    tst = tst  & ~SkMskConst
    ENDIF
   ENDIF
  pY = WReg
  ENDIF

 IF pX = WReg 
  IF (tst & SkMskNeq) > 1
   ;Flip the operation around.
   tst = tst ^ SkMskFlip
   ENDIF
  pX = pY
  pY = WReg
  ENDIF

;At this point, pX is NOT w
; for sxkey change this to <> rather than !=
 IF pY != WReg
  IF pY>$0F ;are we about to access a non-global register?
	expand
 bank pY  ;non-global
	noexpand
   SkcBank = pY / $10
   ENDIF
  IF tst = Gt OR tst = LE
	expand
 mov w, ++pY
	noexpand
   ;if tst was Gt its now GE if it was LE its Lt
   tst = tst ^ SkMskC
  ELSE ; tst = GE, Lt, Eq, NE
	expand
 mov w, pY
	noexpand
   ENDIF
  pY = WReg
  ENDIF

;At this point, pY is in W. pX is a register or a constant

 IF pX>$0F AND (pX / $10) <> SkcBank  AND tst & SkMskConst = 0
  ;are we about to access a non-global register in a new bank?
	expand
 bank pX  ;non-global
	noexpand
  ENDIF

 IF tst = Eq OR tst = NE OR tst = EqN OR tst = NEN
  IF tst = EqN OR tst = NEN
	expand
 xor w, #pX
	noexpand
   tst = tst  & ~SkMskConst
  ELSE
	expand
 xor w, pX
	noexpand
   ENDIF
  IF tst = Eq
	expand
 sz
	noexpand
  ELSE
	expand
 snz
	noexpand
   ENDIF
 ELSE
  IF CpuCarry
   IF tst = Gt OR tst = LE
	expand
 clc
	noexpand
   ELSE
	expand
 stc
	noexpand
    ENDIF
   ENDIF

	expand
 mov w, pX - w
	noexpand
  IF tst = Lt OR (tst = LE AND CpuCarry)
	expand
 snc
	noexpand
  ELSE
	expand
 sc
	noexpand
   ENDIF
  ENDIF
  
 IF !CpuCarry AND (tst = Gt OR tst = LE)
	expand
 snz
	noexpand
  ENDIF
 IF tst = Gt AND NOT CpuCarry
	expand
 skip
	noexpand
  ENDIF
 ENDM


Skz MACRO 2
;Usage: Skz register, [IsZero | IsNotZero]
	noexpand
 IF \1>$0F
	expand
 bank \1 ;non-global
	noexpand
  ENDIF
	expand
 test \1
	noexpand
 IF \2 = IsZero
	expand
 sz
	noexpand
 ELSE
  IF \2 = IsNotZero
	expand
 snz
	noexpand
  ELSE
   error 'Usage: Skz register, [IsZero | IsNotZero]'
   ENDIF
  ENDIF  
 ENDM



Stack5 = 0
Stack4 = 0
Stack3 = 0
Stack2 = 0
StackTOS = 0

StackLevel = 1
StackDepth = 5

StackPUSH MACRO
 noexpand
 StackLevel = StackLevel + 1
 IF StackLevel > StackDepth
  ERROR 'Stack Overflow'
  ENDIF
 Stack5 = Stack4
 Stack4 = Stack3
 Stack3 = Stack2
 Stack2 = StackTOS
 ENDM

StackPOP MACRO
 noexpand
 StackLevel = StackLevel - 1
 IF StackLevel < 1
  ERROR 'Stack Underflow'
  ENDIF
 StackTOS = Stack2
 Stack2 = Stack3
 Stack3 = Stack4
 Stack4 = Stack5
 Stack5 = 0
 ENDM

Repeat MACRO
 noexpand	;incase expand was already on.
 StackPUSH
 StackTOS = $
 ENDM

Until MACRO 
	noexpand
 IF \0 = 2
  Skz \1,\2
 ELSE
  Skc \1,\2,\3
  ENDIF
 expand
 jmp @StackTOS
 noexpand
 StackPOP
 ENDM

While	MACRO 
	noexpand
 IF \0 = 2
  Skz \1,\2^SkMskSwap
 ELSE
  Skc \1,\2^SkMskSwap,\3
  ENDIF
	expand
 jmp @StackTOS
	noexpand
 StackPOP
 ENDM

WhileDec MACRO 1
 noexpand
 expand
 djnz \1, @StackTOS
 noexpand
 StackPOP
 ENDM

WhileNotZero MACRO 0
 noexpand
 expand
 jnz @StackTOS
 noexpand
 StackPOP
 ENDM

WhileZero MACRO 0
 noexpand
 expand
 jz @StackTOS
 noexpand
 StackPOP
 ENDM

WhileNoCarry MACRO 0
 noexpand
 expand
 jnc @StackTOS
 noexpand
 StackPOP
 ENDM

WhileCarry MACRO 0
 noexpand
 expand
 jc @StackTOS
 noexpand
 StackPOP
 ENDM

Forever	MACRO 
	noexpand	;incase expand was already on.
	expand
 jmp @StackTOS
	noexpand
 StackPOP
 ENDM

doifadr = 0
doendifadr = 0
doifl = 0

doif MACRO
	noexpand
 doifl = doifl + 1
 IF doifl > 2
	error 'Only 2 levels of nested conditions supported by doif macro'
  ENDIF
 IF \0 = 2
  Skz \1,\2
 ELSE
  Skc \1,\2,\3
  ENDIF
	expand
 doifadr = doifadr * 2048 + $	;save space here for a jmp
	noexpand		;figure out where the jmp will be from
 org $+2			; and leave space for it
 ENDM

DoElse MACRO
	noexpand
  IF doifl < 1
	error 'DoElse outside of DoIf/DoEndIf block'
    ENDIF
;remember where we were,
;go back to where the jmp needs to be
;jmp to where we were
;go back to where we were
	expand			
 doendifadr = doendifadr * 2048 + $
 org doifadr // 2048	; go back
 jmp @(doendifadr // 2048)+2; do the jmp
 org doendifadr // 2048	; come forward
 doendifadr = doendifadr / 2048
 doifadr = (doifadr & ~1023) + $	;save space here for a jmp
	noexpand		;figure out where the jmp will be from
 org $+2			; and leave space for it
 ENDM

DoElseIf MACRO
	noexpand
 IF doifl < 1
	error 'DoElseIf outside of DoIf/DoEndIf block'
  ENDIF
;remember where we were,
;go back to where the jmp needs to be
;jmp to where we were
;go back to where we were
	expand			
 doendifadr = doendifadr * 2048 + $
 org doifadr // 2048	; go back
 jmp @(doendifadr // 2048); do the jmp
 org doendifadr	; come forward
 doendifadr = doendifadr / 2048
	noexpand
 IF \0 = 2
	Skz \1,\2
 ELSE
	Skc \1,\2,\3
  ENDIF
	expand
 doifadr = (doifadr & ~1023) + $	;save space here for a jmp
	noexpand		;figure out where the jmp will be from
	org $+2			; and leave space for it
 ENDM

DoEndIf MACRO
	noexpand
 IF doifl < 1
	error 'DoEndIf outside of DoIf/DoEndIf block'
  ENDIF
 doifl = doifl - 1
;remember where we were,
;go back to where the jmp needs to be
;jmp to where we were
;go back to where we were
	expand			
 doendifadr = doendifadr * 2048 + $
 org doifadr // 2048	; go back
 jmp @(doendifadr // 2048)	; do the jmp
 org doendifadr // 2048	; come forward
 doendifadr = doendifadr / 2048
 doifadr = doifadr / 2048
	noexpand
 ENDM


Push MACRO 1
 noexpand
 parm = \1
 expand
 DecBufPtr StackPtr	;could use incsz rather than inc to avoid modifying Z
 noexpand
 IF Parm = Wreg OR parm = fsr
  IF parm = fsr
  ELSE
   expand
 mov fsr, w	;fsr could be anything (due to bank etc..) so use for parm
   noexpand
  parm = WReg
   ENDIF
	expand
 mov w, StackPtr ;get the StackPtr into w
 xor fsr, w	;swap w with fsr
 xor w, fsr
 xor fsr, w
 mov ind, w	;store w to Top Of Stack.
	noexpand
 ELSE
	expand
 mov fsr, StackPtr ;W used
  noexpand
  IF parm > $0F
   expand
 bank parm
 mov w, parm
 bank Stack
 mov ind, w
   noexpand
  ELSE
   expand
 mov ind, parm
   noexpand
   ENDIF
  ENDIF
 ENDM
 
Pop MACRO 1
 noexpand
 expand
 mov fsr, StackPtr ;W used
 mov w, ind
 noexpand
 IF \1 > $0F
  expand
 bank \1
  noexpand
  ENDIF
  expand
 mov \1,w
 ;\1 is now the StackPtr
 IncBufPtr StackPtr ;point to valid data at new Top Of Stack
  noexpand
 ENDM

LookupW MACRO
 noexpand
;Defines an in-line DW/IREAD lookup table returns the 12 bit value indexed by W in M:W.
;Affects M and W.
 expand
 jmp @$+\0+2
; IF \0
_LookupWTableBegin = $
 noexpand
 REPT \0
 expand
 DW \%
 noexpand
 ENDR
_LookupWTableEnd = $
 expand
 IF _LookupWTableBegin & $FF = 0
 ELSE
 mov temp,w	;WARNING temp modified by macro
 mov w, #_LookupWTableBegin & $FF
 add w, temp	;offset from start of table
  ENDIF
 mov m,#_LookupWTableBegin>>8
 IF	(_LookupWTableBegin / $100) = (_LookupWTableEnd / $100)
 ELSE
 snc		;correct if carry
 mov m,#_LookupWTableBegin>>8+1	
 ENDIF
 iread 		;Retrieve data
 noexpand
 ;{use the data}
 ENDM

;	IF (($+0)/$100)//2 = 1
;pagehalf = ($/$100)//2
;nextpage = (($/$100)+1) * $100
;	org	(($/$100)+1)*$100
;	org $200
;	ENDIF
;	ENDM

Subroutine MACRO
 noexpand
;Usage: Define a Global lable, 
; Execute Subroutine macro, 
; Assign :Entry to the value now set in SubEntryAddr. 
; Continue the definition of the subroutine. 
; Elsewhere, call @Sub:Entry where Sub is the global lable
;  you defined for the subroutine.
;Example
;SUB1	Subroutine 
;:Entry = SubEntryAddr
;....
;	Call SUB1:Entry
 _SubAddr = $
 IF (_SubAddr & $100) = 0 
 ELSE
  org LowHalfPage
  SubEntryAddr = $
;if we got here, the pagesel bits must be set for here
  IF ($ / $100) = (_SubAddr / $100)
   expand
 jmp _SubAddr
   noexpand
  ELSE
   expand
 jmp @_SubAddr
   noexpand
   ENDIF
  LowHalfPage = $
  IF $+1 > HighHalfPage
   ERROR 'Out of LowHalfPage Space'
   ENDIF
  org _SubAddr
 ELSE ;The subroutine was already starting in a LowHalfPage
  SubEntryAddr = $
  ENDIF
 ENDM

binjump MACRO
;Call with the first parameter of the register to tbe tested and
;the following parameters a list of addresses to jump to based on
;the value of the register.
;More effecient than a long jump table for 4 or fewer addresses
 noexpand
 if \0 > 5
  if \0 = 6
   expand
   jb \1.2, @\6	;=4
   noexpand
   binjump \1,\2,\3,\4,\5
  else
   expand
   jb \1.2, @:2Set ;>4 ;@$+16
   noexpand
   binjump \1,\2,\3,\4,\5
   expand
:2Set
   noexpand
   if \0 > 7
    if \0 > 8
     binjump \1,\6,\7,\8,\9
    else
     binjump \1,\6,\7,\8
     endif
   else
    binjump \1,\6,\7
    endif
   endif
 else ;5 or less
  if \0 > 3
   if \0 = 4
    expand
  jb \1.1, @\4 ;=2 or 6
    noexpand
    binjump \1,\2,\3
   else
    expand
  jb \1.1, @:1Set ;>2 or >6; $+8
    noexpand
    binjump \1,\2,\3
    expand
:1Set
    noexpand
    binjump \1,\4,\5
    endif
 else
  expand
 jnb \1.0,@\2
 jmp @\3
  noexpand
  endif
 endif
 endm

GotoW MACRO
 noexpand
;must be invoked after all parameters are defined 
;i.e. no forward references.
;if you manually expand the macro, forward refs may work?
 _SaveAddr = $
 _GotoWPage = _SaveAddr / $200
 REPT \0
  IF (\% / $200) = (_SaveAddr / $200)
  ELSE
   _GotoWPage = (\% / $200) ;
   ENDIF
  ENDR
 IF _GotoWPage != (_SaveAddr / $200) OR ((_SaveAddr // $200) > $FF) ;has to be a long jump table
  IF \0 > 127
   ERROR 'Long jumps must be used and no more than 127 entries can be supported'
   ENDIF
  IF \0 = 2
   binjump WReg, \1, \2
   EXITM
   ENDIF
  IF \0 = 3
   binjump WReg, \1, \2, \3
   EXITM
   ENDIF
  IF \0 = 4
   binjump WReg, \1, \2, \3, \4
   EXITM
   ENDIF
  IF LowHalfPage + (\0*2) + 1 > HighHalfPage
    ERROR 'Out of LowHalfPage Space'
    ENDIF
  org LowHalfPage
  _GotoWPage = 0
 ELSE
  IF \0 > 255
   ERROR 'No more than 255 entries can be supported'
   ENDIF
  IF \0 = 2
   binjump WReg, \1, \2
   EXITM
   ENDIF
  IF LowHalfPage + \0 + 1 > HighHalfPage
    ERROR 'Out of LowHalfPage Space'
    ENDIF
  ENDIF
 expand
 _GotoWTableBegin = $
 add PC,W ;jump to the jump
 noexpand
 REPT \0
  IF _GotoWPage = 0
   expand
 jmp @\%
   noexpand
  ELSE
 expand
 jmp \%
 noexpand
   ENDIF
  ENDR
 IF _GotoWPage = 0 ;its a long jump table
  LowHalfPage = $
  org _SaveAddr
 expand
 clc
 rl WReg ;need long jumps
 ;WARNING: Insure OPTION:RWT = 0
 jmp @_GotoWTableBegin
 noexpand
   ENDIF
 ENDM

DecBufPtr MACRO 1
 noexpand
;decrements buffer pointers and keeps them within one bank
 IF CPUPins > 28
  expand
 dec \1
 setb \1.5
  noexpand
 ELSE
  expand
 dec \1
 setb \1.4
  noexpand
  ENDIF
 ENDM

IncBufPtr MACRO 1
 noexpand
;increments buffer pointers and keeps them within one bank
 IF CPUPins > 28
  expand
 clrb \1.5
 inc \1
 setb \1.5
  noexpand
 ELSE
  expand
 clrb \1.4
 inc \1
 setb \1.4
  noexpand
  ENDIF
 ENDM

mmov Macro 3
 noexpand
 _bank = 0
 rept \3
  IF ((\2 + % -1) / $10) = _bank
	ELSE
   _bank = (\2 + % -1) / $10
   expand
 bank (\2 + % -1)
   noexpand
   ENDIF
  expand
 mov w, (\2 + % -1)
  noexpand
  IF ((\1 + % -1) / $10) = _bank
	ELSE
   _bank = (\1 + % -1) / $10
   expand
 bank (\1 + % -1)
   noexpand
   ENDIF
  expand
 mov (\1 + % -1), w
  noexpand
  ENDR
 ENDM

VMGetTok Macro 
 expand
 Call @OP:GetTok
 noexpand
 ENDM

VMGetNewTok Macro 
 expand
 Call @OP:GetNewTok
 noexpand
 ENDM

VMGetHexTok Macro 
 expand
 Call @OP:GetHexTok
; Call @OP:GetTok
 noexpand
 ENDM

VMNext Macro
 expand
 jmp @OP:DoOps
 noexpand
 ENDM

;PORTS ---------------------------------------------------------------------------

IF CpuPins > 28
StatusPort	=	rb	;status port for driven printer and PC status lines
PnAck		=	StatusPort.0	;in  neg
PBusy		=	StatusPort.1	;in  pos
PrnOOP		=	StatusPort.2	;in  pos Out of Paper
PrnSelect	=	StatusPort.3	;in  pos
PrnNError	=	StatusPort.4	;in  neg
HnStrobe	=	StatusPort.5	;in  pos
StatusPortDir	=	$FF		;all in

;port B interrupt pin (0=enable, 1=disable)
rbIntMask	=	0

;port B interrupt edge (0=rising, 1=falling)
rbIntEdge	=	(1 << (PnAck/$100)) | (1 << (PrnNError/$100)) | (1 << (HnStrobe/$100))

ControlPort	=	rc	;status port for non-driven printer and PC status lines
PnStrobe	=	ControlPort.0	;out pos
PrnAuto		=	ControlPort.1	;out neg /Auto Feed
PrnInit		=	ControlPort.2	;out neg /Initiallize
PrnSelectIn	=	ControlPort.3	;out neg /Select Input
HnAck		=	ControlPort.4	;out neg
HBusy		=	ControlPort.5	;out pos
PcOOP		=	ControlPort.6	;out pos Out of Paper
ControlPortDir	=	$00		;all out

PPPort		=	rd	;printer data port
PPPortDir	=	$00	;output port
IF DebugMemSPI > 2 AND DebugPP < 1
DebugPort	=	rd	;debug bits
ENDIF

PCPort		=	ra	;PC data port
PCPortDir	=	$FF	;All in

MemSpiPort	=	re	;SPI interface to Atmel AT45D081 1Mb FLASH Memory
MemSpiSI	=	MemSpiPort.0	;out pos	Status.C
MemSpiSCK	=	MemSpiPort.1	;out pos	Status.DC (we can clear it)
MemSpiSO	=	MemSpiPort.0	;in  pos	Status.C (share with SI)
MemSpiSIO	=	MemSpiPort.0	;    pos	Status.C (common)
MemSpiNCS	=	MemSpiPort.2	;out neg	Status.Z (scary)
MemSpiNCS3	=	MemSpiPort.5	;out neg	Status.PA0 (we can clear it)
MemSpiNCS2	=	MemSpiPort.6	;out neg	Status.PA1 (we can clear it)
;Since PD and TO don't wan't to clear, aligning them with RS232 Rx and Gnd and aligning
;Tx with PA3 which will normally be zero will keep the serial port idle during SPI ops
RS232Gnd	=	MemSpiPort.3	;out not Tx	Status.PD (we can't clear it)
RS232Rx		=	MemSpiPort.4	;in  neg	Status.TO (we can't clear it)
RS232Tx		=	MemSpiPort.7	;out neg	Status.PA3 (we can clear it)
MemSpiPortDir	=	(1<<(MemSpiSO/$100)) | (1<<(RS232Rx/$100))

ELSE	;CPUPins = 28

PDataPort	=	rc	;printer/PC data port

StatusPort	=	rb	;status port for printer and PC status lines

CtrlPort	= 	ra
CtrlD0		=	CtrlPort.0
CtrlD1		=	CtrlPort.1
CtrlA0		=	CtrlPort.2
CtrlA1		=	CtrlPort.3
CtrlA2		=	StatusPort.1
CtrlnE		=	StatusPort.0
CtrlPortDir	=	$F0	;All out
CtrlData	=	CtrlD0
CtrlAddrLow	=	CtrlA0
CtrlAddrHi	=	CtrlA2

	watch	CtrlData,2,UDEC
	watch	CtrlAddrLow,2,UDEC
	watch	CtrlAddrHi,1,UDEC
	watch	CtrlnE,1,UDEC

CtrlInt		=	0	;just a flag that A2 needs to get cleared
CtrlExt		=	%10000	;just a flag that A2 needs to get set


;SPI interface to Atmel AT45D081 1Mb FLASH Memory
CtrlMemSpiData	=	CtrlInt | (0<<(CtrlA0/$100)) | (0<<(CtrlA1/$100));Q0
;CtrlA0 and CtrlA1 align with Status.Z and Status.PD
MemSpiPort	=	ra
MemSpiNCS	=	0
MemSpiSI	=	CtrlD0	;out pos	Status.C
MemSpiSCK	=	CtrlD1	;out pos	Status.DC (we can clear it)
MemSpiSO	=	CtrlD0	;in  pos	Status.C (share with SI)
MemSpiSIO	=	CtrlD0	;    pos	Status.C (common)
MemSpiPortDir	=	CtrlPortDir & ~(1<<(MemSpiSO/$100))

CtrlMemSpiSel	=	CtrlInt | (1<<(CtrlA0/$100)) | (0<<(CtrlA1/$100));Q1
FRAMnCS		=	(1<<(CtrlD0/$100)); Q1 D0 on
FRAMCS		=	~FRAMnCS
FLASHnCS	=	(1<<(CtrlD1/$100)); Q1 D1 on
FLASHCS		=	~FLASHnCS
SelFLASH	=	CtrlMemSpiSel & FLASHCS + ~FRAMCS
SelFRAM		=	CtrlMemSpiSel + ~FLASHCS & FRAMCS
SelNoMemSpi	=	CtrlMemSpiSel + ~FLASHCS + ~FRAMCS

CtrlRamData	=	CtrlInt | (0<<(CtrlA0/$100)) | (1<<(CtrlA1/$100));Q2
RAMEnable	=	(1<<(CtrlD0/$100)); Q2 D0 on
RAMRnW		=	(1<<(CtrlD1/$100)); Q2 D1 on

CtrlRamSel	=	CtrlInt | (1<<(CtrlA0/$100)) | (1<<(CtrlA1/$100));Q3
_269HnPE	=	(1<<(CtrlD0/$100)); Q3 D0 on
_269LnPE	=	(1<<(CtrlD1/$100)); Q3 D1 on

RAMnOE		=	CtrlA0
_269CP		=	CtrlA0

CtrlHostData	=	CtrlExt | (0<<(CtrlA0/$100)) | (0<<(CtrlA1/$100));Q4
_245nOE		=	(1<<(CtrlD0/$100)); Q4 D0 on
_245OE		=	~_245nOE
PnStrobe	=	(1<<(CtrlD1/$100)); Q4 D1 on
PStrobe		=	~PnStrobe
HostPStrobe	=	CtrlHostData & _245OE & PStrobe
DataPStrobe	=	CtrlHostData + _245nOE & PStrobe
HostDataDrive	=	CtrlHostData & _245OE + ~PStrobe
HostDataRelease	=	CtrlHostData + _245nOE + ~PStrobe
PlugDataDrive	=	HostDataRelease
;CtrlHostStat is at Q6 rather than Q5 because you can get from 4 to 6 with one bit...

CtrlRS232	=	CtrlExt | (1<<(CtrlA0/$100)) | (0<<(CtrlA1/$100));Q5
RS232TxMark	=	CtrlRS232 | (0<<(CtrlD0/$100)) | (1<<(CtrlD1/$100))
RS232TxSpace	=	CtrlRS232 | (1<<(CtrlD0/$100)) | (0<<(CtrlD1/$100))
RS232Tx		=	(1<<(CtrlD0/$100)); Q5 D0 on	;out neg	Status.C
RS232Rx		=	StatusPort.7	;in  neg 
RS232Gnd	= 	0

CtrlHostStat	=	CtrlExt | (0<<(CtrlA0/$100)) | (1<<(CtrlA1/$100));Q6
HBusy		=	(1<<(CtrlD0/$100)); Q6 D0 on
HnAck		=	(1<<(CtrlD1/$100)); Q6 D1 on
HAck		=	~HnAck
HostAck		=	CtrlHostStat & ~HBusy & HAck
HostAckBusy	=	CtrlHostStat + HBusy & HAck
HostReady	=	CtrlHostStat & ~HBusy + ~HAck
HostBusy	=	CtrlHostStat + HBusy + ~HAck

CtrlTerm	=	CtrlExt | (1<<(CtrlA0/$100)) | (1<<(CtrlA1/$100));Q7
LCDEn		=	(1<<(CtrlD0/$100)); Q7 D0 on
KBDEn		=	(1<<(CtrlD1/$100)); Q7 D1 on

PcEN		=	CtrlPort.0	;out pos Enables PC to PRN comms
PcDir		=	CtrlPort.1	;out pos Reverses PC to PRN data direction
					;via 74LS245 MUST BE HIGH! 1k pullup on PCB

StatusPort	=	rb	;status port for printer and PC status lines
CtrlnE		=	StatusPort.0
CtrlA2		=	StatusPort.1
HnAutoFeed	=	StatusPort.2	;in  neg (past) host
HnSelectIn	=	StatusPort.3	;in  pos (past) host
IEEE1284	=	HnSelectIn
HnStrobe	=	StatusPort.4	;in  pos
PBusy		=	StatusPort.5	;in  pos
PnAck		=	StatusPort.6	;in  neg
RS232Rx		=	StatusPort.7	;in  neg 

;Status Port Direction (0=out, 1=in)
StatusPortDir	= 	$FF & ~(1<<(CtrlA2/$100)) & ~(1<<(CtrlnE/$100))
;port B interrupt pin (0=enable, 1=disable)
rbIntMask	=	$00 | (1<<(CtrlA2/$100)) | (1<<(CtrlnE/$100))
;for now, don't take interrupts from the RS232 port
rbIntMask	= 	rbIntMask | (1<<(RS232Rx/$100))
;and don't take unnecessary interrupts from the peripheral.
rbIntMask	= 	rbIntMask | (1<<(PBusy/$100))
;and don't take unnecessary interrupts from the Host.
rbIntMask	= 	rbIntMask | (1<<(HnSelectIn/$100)) | (1<<(HnAutoFeed/$100))

IF DebugPP < 1
;if debugging only the host, don't take interrupts from the peripheral.
rbIntMask	= 	rbIntMask | (1<<(PnAck/$100)) | (1<<(PBusy/$100))
 ENDIF
IF DebugPC < 1
;if debugging only the peripheral, don't take interrupts from the Host.
rbIntMask	= 	rbIntMask | (1<<(HnStrobe/$100))
rbIntMask	= 	rbIntMask | (1<<(HnSelectIn/$100)) | (1<<(HnAutoFeed/$100))
 ENDIF

;port B interrupt edge (0=rising, 1=falling) collect up all the neg's
rbIntEdge	=	(1 << (PnAck/$100)) | (1 << (HnAutoFeed/$100))
rbIntEdge = rbIntEdge | (1<<(HnStrobe/$100)) | (1<<(HnSelectIn/$100))

;rbIntEdge = rbIntEdge | (1<<(RS232RX/$100))
rbIntHMsk	=	(1<<(HnStrobe/$100)) | (1<<(HnSelectIn/$100)) | (1<<(HnAutoFeed/$100))
rbIntPMsk	=	(1<<(PnAck/$100)) | (1<<(PBusy/$100))


PDataPort	=	rc	;printer/PC data port
IF DebugMemSPI > 2 AND DebugPP < 1
DebugPort	=	rc	;debug bits
ENDIF
;PDataPortDir	=	variable
nError		=	PDataPort.0	;in  neg (past) via a big resistor
nInit		=	PDataPort.1	;in  neg (past) via a big resistor
Select		=	PDataPort.2	;in  pos (past) via a big resistor

ENDIF




;VARIABLES ***********************************************************************
;ds allocates registers starting from the register number specifed by the org
;address which does not relate to a program memory address
;GLOBAL VARIABLES ----------------------------------------------------------------
		org	GPRegOrg
Temp		ds	1
ISRTemp		ds	1
VMTemp		ds	1
Tok		ds 	1	;the Token currently being decoded.
Count		ds	1

flags		ds	1
timerflag		=	flags.0
MatchComplete 		= 	flags.1
BufDstPtrMov		=	flags.2
BufSrcPtrMov		=	flags.3
VMSaveCarry		=	flags.4
VMSaveZero		=	flags.4
VMDoIt			=	flags.6

StackPtr	ds	1	;Stack Pointer

IF DebugMemSPI > 2
 IF DebugPP > 0
DebugPort	ds	1
  ENDIF
;ErrBufReadBack	=	DebugPort.7	;a buffer didn't read back what it was written
;ErrPgReadback	=	DebugPort.6	;a page didn't read back what it was written
;ErrNoWait	=	DebugPort.5	;I didn't have to wait for a write to complete
;ErrWaitTimeOut	=	DebugPort.4	;I waited and it didn't get done
;ErrLoopDone	=	DebugPort.3	;1 complete debug loop (toggle)
ErrBufReadBack	=	DebugPort.0	;a buffer didn't read back what it was written
ErrPgReadback	=	DebugPort.1	;a page didn't read back what it was written
ErrNoWait	=	DebugPort.2	;I didn't have to wait for a write to complete
ErrWaitTimeOut	=	DebugPort.3	;I waited and it didn't get done
ErrLoopDone	=	DebugPort.4	;1 complete debug loop (toggle)

	watch ErrBufReadBack,1,ubin
	watch ErrPgReadback,1,ubin
	watch ErrNoWait,1,ubin
	watch ErrWaitTimeOut,1,ubin
	watch ErrLoopDone,1,ubin
 ENDIF

IF $ > $10
 ERROR 'out of gobal variable space'
 ENDIF
;BANK 0 VARIABLES ----------------------------------------------------------------
			org	$10	;$10 to $1F - limited to 16 bytes - bank 0
bank0			=	$

PPVPMem			=	$
PCVPMem			=	$
PPNext			ds	1	;Parallel Port State Machine Index.
PCNext		=	PPNext
;low nibble=PPVP State, high nibble=PCVP State
PPBufEmpty	=	PPNext.3	;PPVP:PPStep8 indicates periph buffer full
PCWaiting	=	PCNext.6	;PCVP:PCStep4 indicates waiting for host data
PPTimeOut		ds	1
PPBufHead		ds	1	;Output Buffer Pointer
PPBufTail		ds	1	;
PCTimeOut		ds	1
PCBufHead		ds	1	;Input Buffer Pointer
PCBufTail		ds	1	;

ISRData			ds	1	;temp storage for state of PDataPort on interrupt

StatusFlags		ds	1	;non-zero=Ack recieved since last check
PnAckFlag	=	StatusFlags.(PnAck/$100)
PBusyFlag	=	StatusFlags.(PBusy/$100)
HnStrobeFlag	=	StatusFlags.(HnStrobe/$100)
			watch StatusFlags, 8, ubin

IF DebugPP>0
			watch PPNext, 4, udec
			watch PPBufHead, 8, uhex
			watch PPBufTail, 8, uhex
			watch PPBufEmpty, 1, ubin
			watch NextChar, 8, udec
			watch PnAckFlag, 1, ubin
			watch PBusyFlag, 1, ubin
 ENDIF
IF DebugPP>1
			watch PnAck, 1, ubin
			watch PBusy, 1, ubin
 ENDIF
IF DebugPC>0
			watch PCNext.4, 4, udec
			watch PCBufHead, 8, uhex
			watch PCBufTail, 8, uhex
			watch PCWaiting, 1, ubin
			watch ISRData, 8, uhex
			watch HnStrobeFlag, 1, ubin
 ENDIF
IF DebugPC>1
			watch HnStrobe, 1, ubin
			watch HnAutoFeed, 1, ubin
			watch HnSelectIn, 1, ubin
 ENDIF

CtrlPortStat		ds	1
;bits 0-3 used to store the state of the CtrlPort
CtrlnEStat	=	CtrlPortStat.4
CtrlA2Stat	=	CtrlPortStat.5

CtrlStatus		ds	2	;Status register for Ctrl lines
StatMemSpiSI	= (CtrlStatus + ((1<<(MemSpiSI/$100))>>1)).(CtrlMemSpiData>>2)
StatMemSpiSCK	= (CtrlStatus + ((1<<(MemSpiSCK/$100))>>1)).(CtrlMemSpiData>>2)
StatFRAMnCS	= (CtrlStatus + (FRAMnCS>>1)).(CtrlMemSpiSel>>2)
StatFLASHnCS	= (CtrlStatus + (FLASHnCS>>1)).(CtrlMemSpiSel>>2)
StatRAMEnable	= (CtrlStatus + (RAMEnable>>1)).(CtrlRamData>>2)
StatRAMRnW	= (CtrlStatus + (RAMRnW>>1)).(CtrlRamData>>2)
Stat_269HnPE	= (CtrlStatus + (_269HnPE>>1)).(CtrlRamSel>>2)
Stat_269LnPE	= (CtrlStatus + (_269LnPE>>1)).(CtrlRamSel>>2)
Stat_245nOE 	= (CtrlStatus + (_245nOE>>1)).(CtrlHostData>>2)
StatPnStrobe 	= (CtrlStatus + (PnStrobe>>1)).(CtrlHostData>>2)
StatRS232Tx	= (CtrlStatus + (RS232Tx>>1)).(CtrlRS232>>2)
StatHBusy 	= (CtrlStatus + (HBusy>>1)).(CtrlHostStat>>2)
StatHnAck	= (CtrlStatus + (HnAck>>1)).(CtrlHostStat>>2)
StatLCDEn	= (CtrlStatus + (LCDEn>>1)).(CtrlTerm>>2)
StatKBDEn	= (CtrlStatus + (KBDEn>>1)).(CtrlTerm>>2)

IF DebugMemSpi>1
	Watch StatMemSpiSI, 1, ubin
	Watch StatMemSpiSCK, 1, ubin
	Watch StatFRAMnCS, 1, ubin
	Watch StatFLASHnCS, 1, ubin
ENDIF

IF DebugPP>1
	watch StatPnStrobe, 1, ubin
 ENDIF
IF DebugPC>0
	watch StatHnAck, 1, ubin
 ENDIF
IF DebugPC>0 OR DebugPP>1
	watch StatHBusy, 1, ubin
	watch Stat_245nOE, 1, ubin
 ENDIF

IF CpuPins > 28
IF DebugPC>0
	watch PCPort, 1, fstr
ENDIF
IF DebugPP>0
	watch PPPort, 1, fstr
ENDIF
ELSE
IF DebugPP>0 or DebugPC>0
	watch PDataPort, 1, fstr
ENDIF
ENDIF
NextChar		ds	1

Timers			=	$	;timer
TimerAccL		ds	1	;timer accumulator low
TimerAccH		ds	1	;timer accumulator high
TimerAccT		ds	1	;timer accumulator top
			watch TimerAccL, 24, uhex

IF $ > $20
 ERROR 'out of variable space'
 ENDIF

;BANK 1 VARIABLES ----------------------------------------------------------------

			org	$30	;$30 to $3F - limited to 16 bytes - bank 1
bank1			=	$
MemSpi			=	$
;SPI interface with Atmel AT45D081 1Mb FLASH Memory

MemSpiData		ds	1
MemSpiDataBit		ds	1	;Which bit am I sending?
MemSpiPortImg		ds	1	;Output image for the port
; Used to hold other signals steady while SI, etc... are toggeling

MemSPIOp		ds	1	;The operation currently being performed

MemSPIStat		ds	1	
MemBufPri	=	MemSpiStat.0	;0=Buf1 is free and inuse as primary, 1=Buf2 free
MemBufSecStat	=	MemSpiStat.1	;0=the secondary buffer is also free
MemOpWait	=	MemSpiStat.3	;a long wait is expected
;MemBuf1XByte	=	MemSPIStat.4	;set to 1 when MemBufPgAddr is pointing to 
MemBufXByte	=	MemSPIStat.5	; bytes above 256 in the page (264 bytes/page)
MemBuf1Dirty	=	MemSPIStat.6	;indicates that Buffer 1 needs to be written
MemBuf2Dirty	=	MemSPIStat.7	;indicates that Buffer 2 needs to be written

MemBufPgAdr		ds	1	;The address of the byte being or most recently
					; read/written to/from the primary Buffer
MemBufPgLo		ds	1
MemBufPgHi		ds	1	;The page # of FLASH cached in the primary Buffer
MemBufData		ds	1	;The current byte being or most recently read
					;  from or written to the primary Buffer

;Not sure if we want this or if we should just load directly into the PPBuf or from PCBuf
;MemBufLByte		ds	1	;The starting address in the free Buffer of the
					; 16 bytes currently in the Mem Local Cache

MemBuf1PgLo		ds	1
MemBuf1PgHi		ds	1	;The current page of FLASH cached in Buffer 1

MemBuf2PgLo		ds	1
MemBuf2PgHi		ds	1	;The current page of FLASH cached in Buffer 2

IF DebugMemSpi>1
	Watch MemSpiPortImg, 8, ubin
	Watch MemSpiDataBit, 3, udec
	Watch MemSpiData, 8, uhex
	Watch MemSpiSIO, 1, ubin
	Watch MemSpiSCK, 1, ubin
	Watch MemSpiOp, 8, uhex
ENDIF

IF DebugMemSpi>0
	Watch MemBufData, 8, uhex
	Watch MemBufPgAdr, 24, uhex
	Watch MemBufXByte, 1, ubin
	Watch MemBufPri, 1, ubin
	Watch MemBuf1Dirty, 1, ubin
	Watch MemBuf1PgLo, 16, uhex
	Watch MemBuf2Dirty, 1, ubin
	Watch MemBuf2PgLo, 16, uhex
ENDIF

IF $ > $40
 ERROR 'out of variable space'
 ENDIF


;BANK 2 VARIABLES ----------------------------------------------------------------
			org	$50	;$50 to $5F - limited to 16 bytes - bank 2
bank2			=	$
PPBuf			ds	16	;Output Buffer
IF DebugPP > 0
			watch PPBuf, 16, fstr
ENDIF
IF $ > $60
 ERROR 'out of variable space'
 ENDIF

;BANK 3 VARIABLES ----------------------------------------------------------------
			org	$70	;$70 to $7F - limited to 16 bytes - bank 3
bank3			=	$
PCBuf			ds	16	;Input Buffer
IF DebugPC > 0
			watch PCBuf, 16, fstr
ENDIF
IF $ > $80
 ERROR 'out of variable space'
 ENDIF


;BANK 4 VARIABLES ----------------------------------------------------------------
			org	$90	;$90 to $9F - limited to 16 bytes - bank 4
bank4		=	$
BufMem		=	$

BufTyp		ds 1 	;Buffer Handlers
; Pointers in tables of jumps to routines that manage buffers.

BufSrcTyp	= BufTyp;In Buffer Handler. 
BufSrcPtr	ds 3 	;In Buffer Pointer. 
;max 24 bit address

BufDstTyp	= BufTyp;Out Buffer Handler. top 4 bits
BufDstPtr	ds 3	;Out Buffer Pointer. max 24 bit address

BufOpTyp	ds 1	;
MatchLen	= BufOpTyp + 0
BufOpPtr	ds 3	;Holds extra parameter for Operation 
; e.g. table to use for lookup
MatchChar	= BufOpPtr + 0
MatchCount	= BufOpPtr + 1
PartMatchCount	= BufOpPtr + 2

BufWidth	ds 1
;for now, just the number of times to repeate the operation. Later:
;Lower 4 bits: 
; The bit width of the values comming from InBuf, how much precision BufOp must have
; and how much space is needed in OutBuf to store one result. 
; Take value from the first digit-'0' after the ','
; maybe  predefined defaults like 'b' for bit ,11 or 'B' Byte ,18 N=,14 W=,1G P=,1/
;Upper 4 bits: 
; How many values to operate on. Take value from the second digit-'0' 0=forever.

VMMem		=	$

;VMTemp	ds 1
;moved to global registers

VMStat		ds	1

;Radix		= 	VMStat ;top 4 bits
;radix to change data to before storing or matching
;RadixBinary	=	Radix.4	;B  00010000
;RadixOctal	=	Radix.7	;O  10000000
;RadixDecimal	=	Radix.5	;D  00100000
;RadixHex	=	Radix.6	;H  01000000

;Tok		ds 1	;the Token currently being decoded.
;Moved to global registers
TokIPTyp	= VMStat;bottom 3 bits. Allows execution of tokens from anywhere.
TokIPPtr	ds 3	;max 24 bit address


IF DebugVM > 0
	watch Tok, 1, FSTR
	watch TokIPTyp, 4, uhex
	watch TokIpPtr, 24, uhex
	watch BufTyp, 4, udec
	watch BufSrcPtr, 24, uhex
	watch BufTyp.4, 4, udec
	watch BufDstPtr, 24, uhex
	watch BufOpTyp, 8, uhex
	watch BufOpPtr, 24, uhex
	watch MatchChar, 1, FSTR
	watch MatchCount, 8, udec
	watch PartMatchCount, 8, udec
	watch MatchComplete, 1, uhex
	watch BufSrcTypSav, 8, uhex
	watch BufSrcPtrSav, 24, uhex
	watch MatchCharSav, 1, FSTR
 ENDIF

IF $ > $A0
 ERROR 'out of variable space'
 ENDIF

;BANK 5 VARIABLES ----------------------------------------------------------------
			org	$B0	;$B0 to $BF - limited to 16 bytes - bank 5
bank5			=	$
Stack			ds	16	;Stack
IF DebugVM > 0
			watch StackPtr, 8, uhex
ENDIF

IF $ > $C0
 ERROR 'out of variable space'
 ENDIF

;BANK 6 VARIABLES ----------------------------------------------------------------
		org	$D0	;$D0 to $DF - limited to 16 bytes - bank 6
bank6		=	$
serial          =       $                       ;UART bank
;
serialflags	ds	1
RS232Rx_flag    =	serialflags.0
RS232RxFrameErr	=	serialflags.1

tx_high         ds      1                       ;hi byte to transmit
tx_low          ds      1                       ;low byte to transmit
tx_count        ds      1                       ;number of bits sent
tx_divide       ds      1                       ;xmit timing (/16) counter
rx_count        ds      1                       ;number of bits received
rx_divide       ds      1                       ;receive timing counter
rx_byte         ds      1                       ;buffer for incoming byte

BufSrcTypSav	ds 1	;In Buffer Handler Save. 
BufSrcPtrSav	ds 3 	;In Buffer Pointer Save. 
MatchCharSav	ds 1

IF $ > $E0
 ERROR 'out of variable space'
 ENDIF

;BANK 7 VARIABLES ----------------------------------------------------------------
		org	$E0	;$E0 to $EF - limited to 16 bytes - bank 7
bank7		=	$

IF $ > $100
 ERROR 'out of variable space'
 ENDIF

;org is now being used to set the starting point in program memory.
		org	0

ISR ;(Interrupt Service Routine) *************************************************
;cycles: 7 + 3 ;it takes 3 cycles to get an interrupt
		bank 0
		mov	ISRData,PDataPort	;preemptivly store the DataPort
		mov	CtrlPortStat,CtrlPort
		snb	CtrlA2
		setb	CtrlA2Stat
		snb	CtrlnE
		setb	CtrlnEStat
:FindSource

:PortB ; ISR ----------------------------------------------------------------------
;cycles: 10 if timer interrupt, ? if external interrupt
		mov	m,#WKPND_B	;clear/check pending external interrupts
		clr	w				
		mov	!rb,w		;with rb only, mov exchanges data, w = pending
		and	w, #~rbIntMask
		test w
;	break
		jz	:PortBOut
		or	StatusFlags, w	;flag any changes in the status lines.
		mov	w, StatusFlags
		and	w, #rbIntHMsk
		jnz	@PCVP
		mov	w, StatusFlags
		and	w, #rbIntPMsk
		jnz	@PPVP
		jmp	@ISR:Out
:PortBOut
		mov	m,#TRIS		;fix the mode.


:Timer  ; ISR -----------------------------------------------------------------------
; 100MHz/60cycles per interrupt = 16,666,666 interrupts per second or one each 0.6us
; / 256 = 6,510.4164 low timer rollovers per second or one each 153.6us
; / 256 = 25.4313 high timer rollovers per second or one each 39.32ms
; / 256 = .099341 top timer rollovers per second or one each 10.06 seconds
; 100MHz/50cycles per interrupt = 2M interrupts per second or one each 0.5us
; / 256 = 7,812.5 low timer rollovers per second or one each 128us
; / 256 = 30.5175 high timer rollovers per second or one each 32.768ms
; / 256 = .119209 top timer rollovers per second or one each 8.388 seconds
; 50MHz/30cycles per interrupt = 16,666,666 interrupts per second or one each 0.6us
; / 256 = 6,510.4164 low timer rollovers per second or one each 153.6us
; / 256 = 25.4313 high timer rollovers per second or one each 39.32ms
; / 256 = .099341 top timer rollovers per second or one each 10.06 seconds
; 50MHz/50cycles per interrupt = 1M interrupts per second or one each 1us
; / 256 = 3,906.25 low timer rollovers per second or one each 256us
; / 256 = 15.258789 high timer rollovers per second or one each 65.536ms
; / 256 = .0596046 top timer rollovers per second or one each 16.777 seconds
; 50MHz/4/120cycles per interrupt = 416,666 interrupts per second or one each 2.4us
; / 256 = 1627.60 low timer rollovers per second or one each 614.401us
; / 256 = 6.35781 high timer rollovers per second or one each 0.157286s
; / 256 = 0.0248352 top timer rollovers per second or one each 40.2653 seconds
;cycles: 6 if not a timer interrupt, 15 if a timer interrupt
		mov	!option,#myOpts | ~OptRTCisW
		cja	rtcc,#-IntPeriod,:End	;check if int caused by rtcc rollover
		clc
		add 	rtcc,#-IntPeriod
		bank	Timers
		incsz	TimerAccL	;416,666 per second, one each 2.4us
		skip
		incsz	TimerAccH	;1627.60 per second, one each 614.401us
		skip
		incsz	TimerAccT	;6.35781 per second, one each 0.157286s
;		skip
;		setb	TimerFlag	;0.0248352 per second, one each 40.2653 seconds
		bank 0			
:TimerOut	
		mov	!option,#myOpts
		jmp 	@VPS	;Continue with Virtual Peripherals

;The Virtual Peripherals are expected to jump back to ISR:Out when done
;but don't stop processing interrupts until there are none left.
:Out = :FindSource	

:End ;-------------------------------------------------------------------------

	mov m,#TRIS 		;Point mode back to ports 
; First, we need to set the Ctrl port back to where it was...
	bank	CtrlPortStat
	setb	CtrlnE
	mov w, CtrlPortStat
	mov CtrlPort, w
IF ((CtrlA2Stat / $100)-4) = (CtrlA2 / $100) AND ((CtrlnEStat / $100)-4) = (CtrlnE / $100)
	swap Wreg
	mov StatusPort, w
ELSE
;WARNING: Why don't you align the port bits with the save bits?
	movb	CtrlA2, CtrlA2Stat
	movb	CtrlnE, CtrlnEStat
 ENDIF
IF CpuLongDate = 1
ELSE
	; << added to correct bug in 9818 chips
	mov m,#WKEN_B 		;Enable Port B interrupts 
	mov !rb,#rbIntMask
	; end bug fix >>
 ENDIF
	mov !option, #myOpts
;	mov	w,#-IntPeriod		;1
	reti				;3 
;retiw adds w to RTCC which avoids jitter due to variations in ISR path or latency.

DO ;=============================================================================
;The interpreter for the token engine
;  ...AND...
;Jump tables for subroutines that have been relocated out of the first half of 
; any program memory page.
;Located here so that A) the stupid computed jumps will
; work and B) so that it can act as a jump table for the routines which are
; actually located under the OP: lable
;binary operations use the Dst as the second Scr. 
;i.e. Dst = Src (Op) Dst or Dst (Op)= Src. 
;e.g. R1 = R2 + R1 or R1 += R2
;expressed as @(dst)(op)(src) 
;@08+1. increments file register 8
;@089.	sets register 8 to a value of 9 (null op is taken as move.)
;@08+@09+@10 sum file registers 9 and 10 into 8
;@08$D+@T*10. adds the next decimal char from the terminal keyboard to file register 8
;@T21,20@T1. moves the top line of the display to the bottom line.
;numbers and letters are taken as values. 
;Starting a new op generates a call to evaluate the previous op and terminates the 
:tok
	bank VMMem
 break
	mov temp, w
	DoIf temp, LEN, '/'
	  DoIf temp, GEN, '!'
	    clc
	    rl wReg
	    jmp pc+w
:mov	    jmp @op:mov		;!	;!! ?
:match	    jmp @op:match	;"
:lookup	    jmp @op:lookup	;#	;use to de-mime incomming code
:radix	    jmp @op:radix	;$	;change radix followed by b=2,d=10,h=16,o=7
:mod	    jmp @op:mod		;%
:and	    jmp @op:and		;&	;&& ?
:xor	    jmp @op:xor		;'
:repeat	    jmp @op:repeat	;(	;Followed by optional count. 
:while	    jmp @op:while	;)	;conditional?
:mul	    jmp @op:mul		;*	;** power
:add	    jmp @op:add		;+	;++ inc
:for	    jmp @op:for		;,	;set width and repeat, zero is forever.
:sub	    jmp @op:sub		;-	;-- dec
:ret	    jmp @op:ret		;.	;return. 
:div	    jmp @op:div		;/
	    doEndIf
	doElseIf temp, LEN, '@'
	  DoIf temp, GEN, ':'
	    clc
	    rl wReg
	    jmp pc+w
:call	    jmp @op:call	;:	;call in token code, define in MetaL
:to	    jmp @op:try		;;	;try following code, failto matching ';'
:lt	    jmp @op:lt		;<	;<= lteq?
:eq	    jmp @op:eq		;=	;== compare or use - (subtract)
:gt	    jmp @op:gt		;>	;>= gteq?
:if	    jmp @op:if		;?	;succeed
:at	    jmp @op:at		;@	;Set Dst then Src buffer. 
					;Followed by 2 char buffer type and pointer. 
	    DoEndIf
;	doElseIf temp, LEN, '_'
;	  DoIf temp, GEN, '^'
;	    clc
;	    rl wReg
;	    jmp pc+w
;	    jmp @op:power	;^
;	    jmp @op:sqrt	;_
;	    doEndIf

	doElseIf temp, EQN, '~'
	  DoIf temp, GEN, '{'
	    clc
	    rl wReg
	    jmp pc+w
:shl	    jmp @op:shl		;{	;shift left
:or	    jmp @op:or		;|	;or
:shr	    jmp @op:shr		;}	;shift right
:neg	    jmp @op:neg ;not	;~ use -0 (minus zero)
	    doEndIf

	  doEndIf
:Out
	retp


TABLES ;*******************************************************
;Jump tables are assembled here by the SUBROUTINE,
; and GOTOW macros.
LowHalfPage = $
HighHalfPage = $100
        org HighHalfPage        ;Leave space in the first LowHalfpage

;STARTUP *************************************************************************
reset_entry		;must be in the first page
	jmp @SETUP

	org $+2		;make sure we have room for the debugger


OP ;=============================================================================
;These are the actual operations that the token engine can perform. 

subroutine ; ---------------------------------------------------------------
OP:GetHexTok = SubEntryAddr
	DoIf Tok,IsZero
	 ;get the next token to execute
	 mov fsr, #TokIPPtr
	 mov w, TokIpTyp
	 call @Buf:Get
	 mov Tok, w
	 inc TokIpPtr+0
	 snz
	  inc TokIpPtr+1
	 snz
	  inc TokIpPtr+2
	 mov fsr, #TokIPPtr
	 mov w, TokIpTyp
	 call @Buf:Get
	 mov temp, w
	 inc TokIpPtr+0
	 snz
	  inc TokIpPtr+1
	 snz
	  inc TokIpPtr+2
	 mov W, #'0'
	 snb Tok.6
	 mov W, #'A'-10
	 stc
	 sub Tok, W
	 sb temp.6
	 mov W, #'0'
	 mov w, temp-w
	 swap Tok
	 add Tok,w
	 DoEndIf
	retp

subroutine ; ---------------------------------------------------------------
OP:GetNewTok = SubEntryAddr
	clr Tok
subroutine ; ---------------------------------------------------------------
OP:GetTok = SubEntryAddr
	DoIf Tok,IsZero
	 ;get the next token to execute
	 mov fsr, #TokIPPtr
	 mov w, TokIpTyp
	 call @Buf:Get
	 mov Tok, w
	 inc TokIpPtr+0
	 snz
	  inc TokIpPtr+1
	 snz
	  inc TokIpPtr+2
	 DoEndIf
	mov w, Tok
	retp

;	 mov fsr, #TokIPPtr
;	 mov w,#2
;	 inc ind
;	 repeat
;	  incsz fsr
;	  snc
;	   inc ind
;	  djnz Wreg,@StackTOS
;	  PopRepeat
;	 DoEndIf
;	mov w, Tok
;	retp

subroutine ; ---------------------------------------------------------------
OP:DoOps = SubEntryAddr
OP:Check = SubEntryAddr
	;execute any operations that are ready to go.
	clc
	mov w, #$EF
	add w, BufTyp
	snc
	 sb dc
	  jmp @OP:Next
;we have a source and a destination
	test BufOpTyp
	snz
	  jmp @OP:Next
;and we have an operation
	setb VMDoIt

subroutine ; ---------------------------------------------------------------
OP:Load = SubEntryAddr
;get the source
	mov fsr, BufSrcPtr
	mov w, BufTyp
	and w, #$0F
	call @Buf:Get
	mov VMTemp, w
;Get the destination (as a second source)
	mov fsr, BufDstPtr
	mov w, BufTyp
	and w, #$F0
	call @Buf:Get
	mov Temp, w
;restore the saved Carry and Zero from the last operation.
	clr Status
	snb VMSaveCarry
	 stc
	snb VMSaveZero
	 stz
;Get the operation and go do it
	mov w, BufOpTyp
	page DO:Tok
	jmp w

OP:Save
;Save the Carry and Zero from this operation.
	clrb VMSaveCarry
	snc
	 setb VMSaveCarry
	clrb VMSaveZero
	snz
	 setb VMSaveZero
;Save the result of the operation
	call @Buf:PutDst
;Conditionally increment the source and destination pointers.
	mov w, #1
	clc
	jnb BufSrcPtrMov, @OP:SaveIncSrc
	 add BufSrcPtr, w
	 snc
	  add BufSrcPtr+1, w
	 snc
	  add BufSrcPtr+1, w
OP:SaveIncSrc
	jnb BufDstPtrMov, @OP:SaveIncDst
	 add BufDstPtr, w
	 snc
	  add BufDstPtr+1, w
	 snc
	  add BufDstPtr+1, w
OP:SaveIncDst

;And that completes one cycle, are there more?
	djnz BufWidth,@OP:Load

OP:Done
	clrb VMDoIt

OP:Next
;	clr Tok	
	call @OP:GetTok
	jmp @DO:Tok

OP:MOV	 ; ---------------------------------------------------------------
	;
	mov BufOpTyp, #DO:MOV
	jnb VMDoIt, @OP:End
	mov temp, VMTemp
	jmp @OP:Save

OP:SHL	 ; ---------------------------------------------------------------
	;{	Shift Left
;??? the problem with this one is that it will not work for multi byte 
;operations unless we START with the LAST byte and work BACKWARDS.
	mov BufOpTyp, #DO:SHL
	jnb VMDoIt, @OP:End
	rl temp
	jmp @OP:Save

OP:OR	 ; ---------------------------------------------------------------
	;|	;|| ?
	mov BufOpTyp, #DO:OR
	jnb VMDoIt, @OP:End
	or temp, VMTemp
	jmp @OP:Save

OP:SHR	 ; ---------------------------------------------------------------
	;{	Shift Right
	mov BufOpTyp, #DO:SHR
	jnb VMDoIt, @OP:End
	rr temp
	jmp @OP:Save

OP:NEG	 ; ---------------------------------------------------------------
	;~	Negate
	mov BufOpTyp, #DO:NEG
	jnb VMDoIt, @OP:End
	not Temp
	jmp @OP:Save

OP:MATCH ; ---------------------------------------------------------------
	;" Before MatchComplete, Match incomming data for count characters
;After MatchComplete, Output data to the closeing quote.
	VMGetNewTok
	mov MatchLen, w
	Repeat
	 VMGetNewTok
	 inc MatchCount
; Until the count is zero
	 jb MatchComplete, @:MatchOut
:MatchIn
; Attempt a match
	 call @Buf:GetSrc
	 bank MatchChar
	 mov MatchChar, w
	 xor w, Tok
	 jnz @:MatchFail
; If a destination is specified copy the data to the output buffer
:MatchOut
	 mov temp, Tok
 ;	 mov temp, MatchChar
	 mov fsr, #BufDstPtr
	 mov w, BufTyp
	 and w, #$70
	 sz
	  call @Buf:Put
	 WhileDec MatchLen
	clr Tok
	VMNext

:MatchFail
	DoIf PartMatchCount, IsZero
;Save the current BufSrc
	 mov w, BufTyp
	 and w, #$07
	 bank BufSrcTypSav
	 mov BufSrcTypSav, w
	 mmov BufSrcPtrSav, BufSrcPtr, 3
;save the character that didn't match
	 mmov MatchCharSav, MatchChar, 1
	
;Make the current TokIp the BufSrc
; break
	 bank VMMem
	 and BufTyp, #~$07
	 mov w, TokIPTyp
	 and w, #$07
	 or BufTyp, w
	 mmov BufSrcPtr, TokIPPtr, 3
	 DoEndIf

;Back up the Src pointer MatchCount chars
	stc
	sub BufSrcPtr+0, MatchCount
	mov w, #1
	sc
	 sub BufSrcPtr+1, w
	sc
	 sub BufSrcPtr+2, w
;add MatchCount to PartMatchCount
	clc
	add PartMatchCount, MatchCount
;	dec PartMatchCount
;Zero MatchCount
	clr MatchCount
	clr Tok
	jmp @OP:FAIL

OP:LOOKUP ; ---------------------------------------------------------------
	;#	;use to de-mime incomming code
OP:RADIX ; ---------------------------------------------------------------
	;$	;change radix followed by B=2,D=10,H=16,O=7
	;affects destination and code (match) NOT source.
IF 0=1
	VMGetNewTok
	mov Radix,w 
	inc Radix
	clr Tok
 ENDIF
	VMNext

OP:RadixChange
IF 0=1
	jnb RadixHex, @OP:RadixHexOut
OP:RadixHex
;convert from Hex by Andrew Warren from
;http://www.sxlist.com/ubicom/lib/math/radix
	mov     W, #'0'
	snb     ind.6
	mov     W, #'A'-10
	sub     ind, W
	inc	fsr
	sb     ind.6
	mov     W, #'0'
	mov	w, ind-w
	swap	WReg
	dec	fsr
	add     W, ind
	VMNext
OP:RadixHexOut
 ENDIF

OP:MOD	 ; ---------------------------------------------------------------
	;%
OP:AND ; ---------------------------------------------------------------
	;&	;&& ?
	mov w, #DO:AND
	mov BufOpTyp, w
	jnb VMDoIt, @OP:End
	AND temp, VMTemp
	jmp @OP:Save
OP:XOR ; ---------------------------------------------------------------
	;'
	mov w, #DO:XOR
	mov BufOpTyp, w
	jnb VMDoIt, @OP:End
	xor temp, VMTemp
	jmp @OP:Save

OP:REPEAT ; ---------------------------------------------------------------
	;(	;Followed by optional count. 
	;index on stack
	; scan back too hard on serial mem.
	;try to buffer loops in FLASH RAM buffer or local "cache"?
	clr Tok
	push TokIPPtr+0
	dec ind
	VMNext

OP:WHILE ; ---------------------------------------------------------------
	;)	;conditional?
	;decrement index at TOS and subtract Tok from TokIPPtr if not zero
	clr Tok
;	pop WReg	;Kill this thread
	pop WReg	;Retrieve the IP that "(" pushed
	sb MatchComplete
	 bank TokIpPtr+0
	 mov TokIpPtr+0, w
	clrb MatchComplete
	VMNext

IF 0=1
OP:VMJmpBak
	VMGetHexTok
	stc
	sub TokIPPtr+0, w
	mov w, #1
	sc
	 sub TokIpPtr+1, w
	sc
	 sub TokIpPtr+2, w
	VMNext
 ENDIF

OP:MUL ;* ---------------------------------------------------------------
		;** power
OP:ADD ;+ ---------------------------------------------------------------
		;++ inc
	mov w, #DO:ADD
	mov BufOpTyp, w
	jnb VMDoIt, @OP:End
	ADD temp, VMTemp
	jmp @OP:Save

OP:FOR ;, ---------------------------------------------------------------
	;,	;set width and repeat, zero is forever.
	VMGetNewTok
	stc
	mov W, #'0'
	mov w, Tok-W
	mov BufWidth, w
	VMNext		

OP:SUB ; ---------------------------------------------------------------
	;-	;-- dec
	mov w, #DO:SUB
	mov BufOpTyp, w
	jnb VMDoIt, @OP:End
	stc
	SUB temp, VMTemp
	jmp @OP:Save

OP:RET ; ---------------------------------------------------------------
	;.	;return. 
;Do whatever is left to do.
;If we had no operation, just do a move.
;	mov w, #DO:MOV
;	test BufOpTyp
;	snz
;	 mov BufOpTyp, w
;???
;	call @OP:DoOps
;Next At(@) is Dst (set src,dst,op to zero)
	and BufSrcTyp, #$F8
OP:FAIL
	and BufDstTyp, #$8F
	clr BufOpTyp
;retrieve previous processor state from the stack
;	Pop TokIPTyp
	Pop TokIPPtr
	clr Tok
	VMNext

OP:DIV ; ---------------------------------------------------------------
	;/
	VMNext

OP:CALL ; ---------------------------------------------------------------
	;:	;call in token code, define in pre-tokenized language
	mmov TokIPTyp, BufSrcTyp, 4
	VMNext

OP:TRY ; ---------------------------------------------------------------
	;;	;forward reference on stack or just scan ahead on fail
;	VMGetHexTok	; ??? switch back to HexTok in final version
	VMGetNewTok
	mov VMTemp, w
	clr Tok
;If we have completed a match, we need to keep skipping forward to the 
;end of the TRY chain.
	jb MatchComplete, OP:VMJmpFwdW
	push VMTemp
	clr BufOpTyp
	clrb MatchComplete
	VMNext
IF 0=1	
OP:VMJmp
	mov TokIpPtr+1, VMTemp
	jnb VMTemp.1, @OP:VMJmp1
	 swap TokIpPtr+1
	 mov w, TokIpPtr+1
	 and w, #$0F
	 mov TokIpPtr+2, W
	 mov w, #$F0
	 and TokIpPtr+1, w
OP:VMJmp1
	jnb VMTemp.0, @OP:VMJmp2
	 clc
	 rl TokIpPtr+1
	 rl TokIpPtr+2
	 rl TokIpPtr+1
	 rl TokIpPtr+2
OP:VMJmp2
	mov w, VMTemp
	and w, #$FC
	or TokIpPtr+1, w
	mov w, Tok
 ENDIF
OP:VMJmpFwdW
	mov TokIPPtr+0, w
	VMNext
OP:LT ; ---------------------------------------------------------------
	;<	;<= lteq?
OP:EQ ; ---------------------------------------------------------------
	;=	;== compare or use - (subtract)
	mov w, #DO:EQ
	mov BufOpTyp, w
	jnb VMDoIt, @OP:End
	mov w, temp
	xor w, VMTemp
	jnz @OP:RET
	clr BufOpTyp
	VMNext
	
OP:GT ; ---------------------------------------------------------------
	;>	;>= gteq?

OP:IF ; ---------------------------------------------------------------
	;?	;success
	clr Tok
;Set MatchComplete
	setb	MatchComplete
;Clear the Destination
	mov w, #$70
	and BufTyp, W
	VMNext

OP:AT ; ---------------------------------------------------------------
	;@
;If the current dst is zero, set the Dst, else set the Src. 
;If setting the source, follow that with a call to the currently set op as long as it isn't zero.
;	call @OP:DoOps	;it will just return if it doesn't have all the
			;information that it needs.
	clr VMTemp
	VMGetNewTok
;make a nice number from the source or destination code.
;0	;00-8F RAM Registers
;1	;FLASH Memory (Mem:Read or Mem:Write)
;2	;Parallel Port (Peripheral (Perp) or Host)
;3	;Que (Push or Pop)
;4	;ROM (Program Memory IREAD or IWRITE if we had a bootloader)
;5	;Serial (RS232In or RS232Out)
;6	;Terminal 

	DoIf Tok, LEN, '9'
	  DoIf Tok, GEN, '0'
;@## (numbers are ram registers). 
; First digit-'0' is the bank, always 8 or less. 0 is global registers
	    mov Count, w;00 01 02 03 04 05 06 07 08
	    clc		
	    rl Count	;00 02 04 06 08 0A 0C 0E 10
	    sz
	    dec Count	;00 01 03 05 07 09 0B 0D 0F
	    swap Count	;00 10 30 50 70 90 B0 D0 F0
	    push Count
; second is the register-'0' in that bank
	    VMGetNewTok
	    sb Tok.6	;if its an @ or higher
	     setb VMTemp.0	; set a flag to inc the pointer
	    and W,#$0F
	    pop Count
	    and Count, w
	    clr W	;W is 0
	    DoEndIf
	DoElseIf Tok, EQN, 'F'
	  mov w, #1	;w is 1
	  setb VMTemp.0	;flag that we will inc the pointer
	DoElseIf Tok, LEN, 'T'
	  DoIf Tok, GEN, 'P'
	    inc WReg		;make 0..4 into 1..5
	    snb WReg.1
	     setb VMTemp.0	;set inc ptr flag for R, S, or T
	    inc WReg		;make 1..5 into 2..6
	    snb WReg.0
	     clrb VMTemp.0	;clr inc ptr flag for Q or S
	    DoEndIf
	DoElse
	  clr Tok
	  jmp @:AtBogus
	  DoEndIf

:AtGotType
	mov temp,w	;save the new buffer type in temp
	mov w, BufTyp	;look at the existing buffer types
; To allow only the source to be set before "?" so that match
;can differentiate between compaire only and copy while compairing
;...set Source first then dest before the "?"
	jb MatchComplete, @:AtAfterMatch
:AtBeforeMatch
	and w, #$07		;mask leaving Source
	jz @:AtNewSrc		;Source IsNotZero?
	and BufTyp,#~$70	;clear the Destination
:AtNewDst
	clrb BufDstPtrMov
	snb VMTemp.0
	 setb BufDstPtrMov
	mov w, <>temp
	or BufTyp, w
	mov VMTemp, #BufDstPtr+2
	jmp @:AtGetAddr

:AtAfterMatch
	and w, #$70		;mask leaving Destination
	jz @:AtNewDst		;Destination IsNotZero?
	and BufTyp, #~$07	;clear the Source
:AtNewSrc
	clrb BufSrcPtrMov
	snb VMTemp.0
	 setb BufSrcPtrMov
	mov w, temp
	or BufTyp, w
	mov VMTemp, #BufSrcPtr+2
;	jmp @:AtGetAddr


:AtGetAddr
;Just process numbers from the TokPtr into memory at VMTemp 
;until I stop getting numbers
; break
	clr Tok
	DoIf temp, IsZero
	 mov fsr, VMTemp
	 mov ind, Count
	DoElse
	mov count,#3
OP:AtGetAddrLoop
	clr temp
	VMGetTok
	clc
	mov w, #'F'
	mov w, tok - w
	jc @OP:AtGetAddrOut

	mov w, #'0'-1
	mov w, tok - w
	jnc @OP:AtGetAddrOut

	mov w, #'@'+1
	sub tok, w
	mov w, #('@' - ':') + 1
	add tok, w
	jnc @OP:AtGetAddrGood
	mov w, #':'-1
	add Tok, w
	jnz @OP:AtGetAddrOut

OP:AtGetAddrGood
	mov w, #(':' - '0')
	sb tok.7
	 mov w, #('A' - '@')+1
	add Tok, w
	push Tok
	VMGetNewTok
	mov     W, #'0'
	snb     Tok.6
	mov     W, #'A'-10
	stc
	mov w, Tok - w
	swap WReg
	pop temp
	add temp,w
	clr Tok
OP:AtGetAddrOut
	mov fsr, VMTemp
	mov ind, temp
	dec VMTemp
	djnz count, @OP:AtGetAddrLoop
	 DoEndIf
OP:AtBogus

OP:Out		
	VMNext
OP:End	
	clr Tok
	VMNext


SPI ;=============================================================================
;   routines for 10MHz (or better) SPI interface to Flash memory. With tight enough
; coding of the buffer read routines (including the sending of the commands to read)
; we can get the transfer of all 1MB of data from the Flash to the printer down to
; an acceptable few seconds.

SPISpeed = 2
;	 = 3 ; 4 cycles/bit 12Mhz 37 bytes (unrolled loops, map STATUS bits to MemSpiPort)
;	 = 2 ; 5 cycles/bit 10Mhz 44 bytes (unrolled loops, no map of STATUS to port)
;	 = 1 ; 8 cycles/bit 6.25Mhz 14 bytes (rolls up the loops)

Subroutine
SPI:SendByte = SubEntryAddr
;--------------------------------------------------------------------
IF SPISpeed < 3 OR (MemSpiSI = MemSpiPort.0 AND MemSpiSCK = MemSpiPort.1 AND MemSpiNCS = MemSpiPort.2 )
ELSE
ERROR 'SCK must align with DC, SI to C, NCS must align with PD'
ENDIF
	bank	MemSPI
IF SPISpeed > 0
	mov	Status, MemSpiPortImg
	clrb	Status.3
	clrb	Status.4
 ENDIF
IF SPISpeed < 2
	mov	MemSpiDataBit,#7	;we will send 8 bits
 ENDIF
	rl	MemSpiData	;setup first data bit in C
IF SPISpeed > 2
	mov	W,Status	;Load port image with data and low SCK and NCS from STATUS

SPI:SendBit	MACRO
	expand
	mov	MemSpiPort,W	;Assert data 
	rl	MemSpiData	;rotate another bit into C
	setb	MemSpiSCK	;Assert clock 
	mov	W,Status	;load port image
	noexpand
	ENDM

ELSE
	CtrlAssert CtrlMemSpiData
	mov w, MemSpiPort
SPI:SendBit	MACRO
	expand
;	clrb MemspiSCK
;	clrb MemSpiSI
	snc
	 setb MemSpiSI
	setb MemSpiSCK
	rl MemSpiData
	mov MemSpiPort, w
	noexpand
	ENDM

IF SPISpeed < 2
:Loop
	SPI:SendBit
	djnz	MemSpiDataBit, :Loop
ELSE
 REPT 8
	SPI:SendBit
  ENDR
ENDIF
	clrb	MemSpiSCK
	ret

Subroutine
SPI:ReadByte = SubEntryAddr
 ;--------------------------------------------------------------------
; Assumeing MemSpiSI is the lowest bit in MemSpiPort
IF SPISpeed = 1
	mov	MemSpiDataBit,#7
 ENDIF
	clrb	MemSpiSCK
	clr	MemSpiData

IF MemSpiSO = MemSpiPort.0
ELSE
ERROR 'MemSpiSO must be bit 0 of MemSpiPort'
 ENDIF
SPI:ReadBit	MACRO
	setb	MemSpiSCK	;Assert clock 1
	mov	W,>>MemSpiPort	;Read Data
	clrb	MemSpiSCK	;Clear clock
	rl	MemSpiData
		ENDM

IF SPISpeed = 1
:Loop
	SPI:ReadBit
	djnz	MemSpiDataBit, :Loop
ELSE
 REPT 8
	SPI:ReadBit
  IF SPISpeed = 2
	mynop
   ENDIF
  ENDR
 ENDIF
	ret

Subroutine
SPI:StartOp  = SubEntryAddr
;---------------------------------------------------------------------
	sb	MemSpiNCS	;if we are in an operation ???
	call	@SPI:EndOp	;end that operation first then
	delay	250, nsec	;wait 250nSec to ensure NCS was high long enough
	clrb	MemSpiSCK	;Select SPI mode 0 (Inactive Clock Polarity Low)
	clrb	MemSpiNCS	;Select the chip (NCS low) ???
	mov	MemSpiPortImg, MemSpiPort
	delay	250, nsec	;wait 250nSec before sending bits
StartOpContinue
	;make sure that MemSpiSI is an output pin
	port	MemSpiPort, out, 1 << (MemSpiSI / $100) | ~MemSpiPortDir
	Call	@SPI:SendByte
	ret

Subroutine
SPI:EndOp = SubEntryAddr 
;-----------------------------------------------------------------------
	clrb	MemSpiSCK	;ensure SCK is off
	delay	250, nsec	;wait 250nSec
	setb	MemSpiNCS	;deselect the chip (NCS high) ???
	mov	MemSpiPortImg, MemSpiPort
	ret

MemSpiIn	MACRO
	port	MemSpiPort, in, 1 << (MemSpiSO / $100) | MemSpiPortDir
	expand
	setb	MemSpiSCK
	delay	25, nSec
	expand
	clrb	MemSpiSCK
	delay	100, nSec
	ENDM

MEM ;=============================================================================
;   routines for interface to SPI Serial Flash memory.

Subroutine
MEM:ReadStatReg = SubEntryAddr 
;-----------------------------------------------------------------
	bank	MemSpi
	mov	MemSpiData,#$57
	Call	@SPI:StartOp
	;make sure that MemSpiSO is an input pin
	MemSpiIn
	Call	@SPI:ReadByte
	ret

Subroutine
MEM:WaitReady = SubEntryAddr
;-------------------------------------------------------------------
	bank	MemSpi
	mov	MemSpiData,#$57
	Call	@SPI:StartOp
	;make sure that MemSpiSO is an input pin
	MemSpiIn
	clr	MemSpiDataBit
WaitReadyLoop
	jnb	MemSpiSO, @:WaitReadyDelay
IF DebugMemSPI>2
	snb	MemOpWait
	setb	ErrNoWait
ENDIF
	ret
:WaitReadyDelay
	delay	84, uSec
	djnz MemSpiDataBit, @WaitReadyLoop
IF DebugMemSPI>2
	setb	ErrWaitTimeOut
ENDIF
	ret

Subroutine
MEM:SendAddr = SubEntryAddr 
;-------------------------------------------------------------------
;Sends the MemBufxPgHi (followed by Lo) address pointed to by fsr 
; with MemBufXByte & Addr. For Buffer read and write, fsr can point anywhere.
;PgHi/Lo is shifted left to make room for XByte. This allows PgHi/Lo/Addr to
; address (with 23bits) a contiguous 8MB by skipping the extra 8 bytes of each page
; (with XByte reset) 
IF MemBuf1PgLo = MemBuf1PgHi-1 AND MemBuf2PgLo = MemBuf2PgHi-1
	mov	w, <<ind
	mov	MemSpiData, w
	dec	fsr
	setb	MemSpiData.0
	sb	ind.7
	clrb	MemSpiData.0
	call	@SPI:SendByte
	mov	w, <<ind
	mov	MemSpiData, w
	setb	MemSpiData.0
	sb	MemBufXByte
	clrb	MemSpiData.0
	call	@SPI:SendByte
	mov	MemSpiData, MemBufPgAdr
	Call	@SPI:SendByte
	inc	fsr
	ret
ELSE
;Sends the address MemBufPgHi<<,Lo<<XByte,Addr to the chip
	mov	w, <<MemBufPgLo		;get PA7 into C
	mov	w, <<MemBufPgHi		;get PA7 into lsb of PgHi
	mov	MemSpiData, w
	Call	@SPI:SendByte
	clc					;get BA8 into C
	snb	MemBufXByte
	stc
	mov	w, <<MemBufPgLo		;get BA8 into lsb of PgLo
	mov	MemSpiData, w
	Call	@SPI:SendByte
	mov	MemSpiData, MemBufPgAdr
	Call	@SPI:SendByte
	ret


Subroutine
MEM:SendPg1Addr = SubEntryAddr 
;-----------------------------------------------------------------
;Sends the address MemBuf1PgHi<<,Lo<< and filler to the chip
	mov	w, <<MemBuf1PgLo		;get PA7 into C
	mov	w, <<MemBuf1PgHi		;get PA7 into lsb of PgHi
	mov	MemSpiData, w
	Call	@SPI:SendByte
	clc
	mov	w, <<MemBuf1PgLo		;get 0 into lsb of PgLo
	mov	MemSpiData, w
	Call	@SPI:SendByte
	mov	MemSpiData, 0
	Call	@SPI:SendByte
	ret

Subroutine
MEM:SendPg2Addr = SubEntryAddr 
;-----------------------------------------------------------------
;Sends the address MemBuf2PgHi<<,Lo<< and filler to the chip
	mov	w, <<MemBuf2PgLo		;get PA7 into C
	mov	w, <<MemBuf2PgHi		;get PA7 into lsb of PgHi
	mov	MemSpiData, w
	Call	@SPI:SendByte
	clc
	mov	w, <<MemBuf2PgLo		;get 0 into lsb of PgLo
	mov	MemSpiData, w
	Call	@SPI:SendByte
	mov	MemSpiData, 0
	Call	@SPI:SendByte
	ret
ENDIF

Subroutine
MEM:BufRead = SubEntryAddr
;--------------------------------------------------------------------
;Starts a new buffer read operation from the current Primary Buffer (MemBufPri) 
;at MemBufPgXByte/Addr to MemBufByte. MemBufPgHi/Lo ignored
	bank	MemSpi
	mov	w,#$54
	snb	MemBufPri
	mov	w,#$56
	mov	MemSpiOp,w
	mov	MemSpiData,w
	Call	@SPI:StartOp
	Call	@MEM:SendAddr
	clr	MemSpiData
	Call	@SPI:SendByte		;just a delay
	MemSpiIn
	Call	@SPI:ReadByte
	mov	MemBufData, MemSpiData
	;inc MemBufPgHi/Lo/XByte/Addr?
	ret

Subroutine
MEM:BufReadNext = SubEntryAddr
;---------------------------------------------------------------
;After call to MEM:BufRead, BufReadNext will produce subsequent bytes until EOF

Subroutine
MEM:BufWrite = SubEntryAddr 
;------------------------------------------------------------------
;Starts a new buffer write operation of MemBufByte to the current Primary Buffer
; (MemBufPri) at MemBufPgXByte/Addr. MemBufPgHi/Lo ignored.
	bank	MemSpi
	mov	w,#$84
	snb	MemBufPri
	mov	w,#$87
	mov	MemSpiOp,w
	mov	MemSpiData,w
	Call	@SPI:StartOp
	Call	@MEM:SendAddr
	mov	MemSpiData, MemBufData
	Call	@SPI:SendByte
	;inc MemBufPgHi/Lo/XByte/Addr?
	snb	MemBufPri		;Which ever buffer got written to
	jmp	@:BufWriteBuf2
	setb	MemBuf1Dirty		; is dirty now
	ret
:BufWriteBuf2
	setb	MemBuf2Dirty
	ret

Subroutine
MEM:BufWriteNext  = SubEntryAddr
;---------------------------------------------------------------
;After call to MEM:BufWrite, BufWriteNext will write MemBufByte to subsequent 
;addresses until EOF

Subroutine
MEM:PgWrite = SubEntryAddr 
;-------------------------------------------------------------------
;Waits for the chip to complete any pending Main Memory operations then tells
;the chip to write the primary buffer to the page address specified in 
;MemBufPgHi/Lo and sets the alternate buffer to be the primary buffer so that
;buffer read/write operations can continue while the page is written.
	bank	MemSpi
	Call	@MEM:WaitReady
	mov	w,#$83
	snb	MemBufPri
	mov	w,#$86
	mov	MemSpiOp,w
	mov	MemSpiData,w
	Call	@SPI:StartOp
	mov	fsr,#MemBufPgHi
	Call	@MEM:SendAddr
	Call	@SPI:EndOp		;Start the write
	sb	MemBufPri		;Which ever buffer got written
	clrb	MemBuf1Dirty		; isn't dirty anymore
	snb	MemBufPri
	clrb	MemBuf2Dirty

MEM:BufSwap
	clrb	MemBufXByte
	jnb	MemBufPri,@MEM:Buf2Pri

MEM:Buf1Pri	;we just wrote Buffer 2
	mov	w, MemBufPgHi
	mov	MemBuf2PgHi, w
	mov	w, MemBufPgLo
	mov	MemBuf2PgLo, w

;	mov	w, MemBuf1PgHi
;	mov	MemBufPgHi, w
;	mov	w, MemBuf1PgLo
;	mov	MemBufPgLo, w

	clrb	MemBufPri
	ret

MEM:Buf2Pri	;we just wrote Buffer 1
	mov	w, MemBufPgHi
	mov	MemBuf1PgHi, w
	mov	w, MemBufPgLo
	mov	MemBuf1PgLo, w

;	mov	w, MemBuf2PgHi
;	mov	MemBufPgHi, w
;	mov	w, MemBuf2PgLo
;	mov	MemBufPgLo, w

	setb	MemBufPri
	ret

subroutine
MEM:PgRead = SubEntryAddr 
;-------------------------------------------------------------------
;Gets the primary buffer loaded with the page address specified in MemBufPgHi/Lo
;and gets the alternate buffer started reading the next page

;- Waits for the chip to complete any pending Main Memory operations (? wait)
;- Checks to see if the requested page is in buffer 1 already, if so
;- - Markes Buffer 1 as the primary buffer
;- else, checks to see if the requested page is in buffer 2 already, if so
;- - Markes Buffer 2 as the primary buffer
;- else, needs to load the page so
;- - checks to see if buffer 1 is "clean" and if so
;- - - makes Buffer 1 the primary buffer
;- - else, checks to see if buffer 2 is clean and if so
;- - - makes Buffer 2 the primary buffer
;- - else, both buffers are "dirty" so
;- - - finds the oldest one (how?)
;- - - makes it the Primary buffer
;- - - waits while writing it out (long wait)
;- - tells the chip to read to the requested page to the primary buffer
;- - Waits for that operation to complete (short wait)
;- checks to see if the alternate buffer is "clean" and if so
;- - tells the chip to start reading the next page to the alternate buffer
;- if the alternate buffer is not "clean"
;- - tells the chip to start writing it

	bank	MemSpi
;- Waits for the chip to complete any pending Main Memory operations (? wait)
	Call	@MEM:WaitReady
;- Check to see if the requested page is in buffer 1 already, if so
	DoIf MemBufPgLo,eq,MemBuf1PgLo
	 DoIf MemBufPgHi,eq,MemBuf1PgHi
;- - Markes Buffer 1 as the primary buffer
	  clrb	MemBufPri
	  jmp	@:PgReadGotIt
	  DoEndIf
	 DoEndIf
;:PgReadNotInBuf1
;- else, checks to see if the requested page is in buffer 2 already, if so
	DoIf MemBufPgLo,eq,MemBuf2PgLo
	 DoIf MemBufPgHi,eq,MemBuf2PgHi
;- - Markes Buffer 2 as the primary buffer
	  setb	MemBufPri
	  jmp	@:PgReadGotIt
	  DoEndIf
	 DoEndIf
;:PgReadNotInBuf2
;- else, needs to load the page so
;- - checks to see if buffer 1 is "clean" and if so
	snb	MemBuf1Dirty
	jmp	@:PgReadBuf1Dirty
;- - - Markes Buffer 1 the primary buffer
	clrb	MemBufPri
	jmp	@:PgReadGotCleanBuf
:PgReadBuf1Dirty
;- - checks to see if buffer 2 is "clean" and if so
	snb	MemBuf2Dirty
	jmp	@:PgReadBuf2Dirty
;- - - Markes Buffer 2 the primary buffer
	setb	MemBufPri
	jmp	@:PgReadGotCleanBuf
:PgReadBuf2Dirty
;- - else, both buffers are "dirty" so
;- - - finds the oldest one (how?)
;just take Buf 1 for now
;- - - markes it the Primary buffer
	clrb	MemBufPri
;- - - waits while writing it out (long wait)
	mov	w,#$83
	mov	MemSpiOp,w
	mov	MemSpiData,w
	Call	@SPI:StartOp
	mov	fsr, #MemBuf1PgHi
; sending the Buf1 Page Hi and Lo address; the primary addr will be ignored
	Call	@MEM:SendAddr
	Call	@SPI:EndOp		;Start the write
;- - - waits for the write to complete (long wait)
	Call	@MEM:WaitReady
:PgReadGotCleanBuf
;- - tells the chip to read the requested page to the primary buffer
	mov	w,#$53
	snb	MemBufPri
	mov	w,#$55
	mov	MemSpiOp,w
	mov	MemSpiData,w
	Call	@SPI:StartOp
	mov	fsr, #MemBufPgHi
	Call	@MEM:SendAddr
	Call	@SPI:EndOp
;update MemBufxPgHi/Lo to reflect the newly read page
	mov	w, #MemBuf1PgHi
	snb	MemBufPri
	mov	w,#MemBuf2PgHi
	mov	fsr,w
	mov	w, MemBufPgHi
	mov	ind,w
	dec	fsr
	mov	w, MemBufPgLo
	mov	ind,w

;- - Waits for that operation to complete (short wait)
	Call	@MEM:WaitReady

:PgReadGotIt
	sb	MemBufPri
	jmp	@:PgReadAlt2

:PgReadAlt1
	mov	fsr, #MemBuf1PgHi
	mov	w,#$83		;w=1000 0011
	sb	MemBuf1Dirty
	mov	w,#$53		;w=0101 0011
	clrb	MemBuf1Dirty	;if it was it won't be soon
	jmp	@:PgReadAlt

:PgReadAlt2
	mov	fsr, #MemBuf2PgHi
	mov	w,#$86		;w=1000 0110
	sb	MemBuf2Dirty
	mov	w,#$55		;w=0101 0101
	clrb	MemBuf2Dirty	;if it was it won't be soon

:PgReadAlt
	mov	MemSpiData, w	;W=opcode
	mov	MemSpiOp, w
	snb	MemSpiOp.7	;if a $5x (vs $8x) op
	jmp	@:PgReadAltDirty
	dec	fsr		;fsr ->MemBufxPgLo
	mov	w, ++MemBufPgLo
	mov	ind, w		;ind is MemBufxPgLo
	inc	fsr		;fsr -> MemBufxPgHi
	clr	w
	add	w, MemBufPgHi	;c has MemBufPgLo overflow
	mov	ind, w
:PgReadAltDirty

;result at this point is
;Alt        MemSpi      fsr       MemBufx
;Buf  dirty Op/Data     ->        Hi/Lo =
;---- ----- ----------- --------- ----------------
; 1    yes  $83 PgFlush MemBuf1Hi MemBuf1Hi/Lo (no change)
; 1    no   $52 PgLoad  MemBuf1Hi MemBufHi/Lo + 1 
; 2    yes  $86 PgFlush MemBuf2Hi MemBuf2Hi/Lo (no change)
; 2    no   $55 PgLoad  MemBuf2Hi MemBufHi/Lo + 1 

	Call	@SPI:StartOp
	Call	@MEM:SendAddr
	Call	@SPI:EndOp		;Start the read
	ret

Subroutine
MEM:Write = SubEntryAddr 
;------------------------------------------------------------------
;Cache writes MemBufByte to MemBufPgHi/Lo/XByte/Addr. If the Page is not 
;currently loaded to the primary or alternate buffer, it reads it in (PgRead),
;updates MemBufxPgHi/Lo and marks the primary buffer (MemBufPri).

Subroutine
MEM:Read = SubEntryAddr 
;------------------------------------------------------------------
;Reads MemBufPgHi/Lo/XByte/Addr to MemBufByte. If the Page is not currently
;loaded to the primary of alternate buffer, it reads it in (PgRead), 
;updates MemBufxPgHi/Lo and marks the primary buffer (MemBufPri).

Subroutine
MEM:FLUSH = SubEntryAddr 
;------------------------------------------------------------------
;Flushes all dirty buffers to FLASH.


Buf ;=============================================================================
;get or put a byte to the buffers assigned to the PPVP, PCVP, and USART

Subroutine
Buf:RRead = SubEntryAddr
	mov w, ind
;	retp		;save a word by falling through Buf:RWrite

Subroutine
Buf:RWrite = SubEntryAddr
	mov ind, w
	retp

Subroutine
Buf:Perp = SubEntryAddr
	Repeat		;wait for space in the buffer to open up.
	  While PPBufTail,eq,PPBufHead
	mov	fsr, PPBufHead
	mov	ind, temp
	bank	PPBufHead	;rebank 'cause mov fsr changed the bank
	DecBufPtr PPBufHead
	bank 	PPNext
	and	PPNext,#$F0	;let the VP know that data is waiting.
	mov	w, temp
	retp

Subroutine
Buf:Host = SubEntryAddr
	bank	PCBufTail
;	Repeat		;wait for data to show up in the buffer
:HostLoop
; break
	mov w, --PCBufTail		;Get the Tail - 1
IF CpuPins < 29
	setb WReg.4			;Set the 4th bit in W (in case the "- 1" wrapped)
 ENDIF
	xor w, PCBufHead		;and compaire it with the Head
	jz @:HostLoop			;
;	  While (--PCBufTail & 4),eq,PCBufHead

	DecBufPtr PCBufTail
	mov	fsr, PCBufTail
	mov	w, ind
	bank	PCBufTail	;rebank 'cause mov fsr changed the bank
	retp

Subroutine
Buf:Pop = SubEntryAddr
	pop Wreg
	retp

Subroutine
Buf:Push = SubEntryAddr
	push temp
	retp

Subroutine
Buf:RS232In = SubEntryAddr
;Recieve byte via serial port (see UART ; )
	bank rx_byte
	jnb     RS232Rx_flag,$	;wait till byte is received 
	clrb    RS232Rx_flag	;reset the receive flag 
	mov     w,rx_byte	;load byte to W

IF 0=1
;Need to: First save the parity bit, either the 8'th bit in 7 bit comms. or the 9'th 
; in 8 bit comms ( with parity ).
; In the case of 7 bit comms do not forget to clear it.

;Calculate Parity as per John Payson (thanks)
;This routine will leave the parity of temp in temp.0
;while blenderizing most of the rest of temp

	mov	W, <>temp	;temp =     abcdefgh  w =     efghabcd
	xor	temp, W		;temp =     abcdefgh  w =     efghabcd
				;    xor efghabcd
	mov	W, >>temp	;temp =     abcdefgh  w =     -abcdefg
				;    xor efghabcd      xor -efghabc
	xor	temp, W		;temp =     abcdefgh  w =     -abcdefg
				;    xor efghabcd      xor -efghabc
				;    xor -abcdefg
				;    xor -efghabc

	; at this point, the parity for half the bits
	; (a, b, e, and f) is in bit 2 of temp, and the
	; parity for the other half (bits c, d, g, and h)
	; is in bit 0 of temp.

	snb	temp.2	; if the parity of (a,b,e,f) is 0,
                        ; then the parity of (a,b,c,d,e,f,g,h)
                        ; is equal to the parity of (c,d,g,h)...
                        ; which is already in bit 0, so skip ahead.


	inc	temp	; otherwise, the parity of (a,b,e,f) is 1,
			; so the parity of (a,b,c,d,e,f,g,h) is
			; NOT equal to the parity of (c,d,g,h).
			; invert bit 0.

	; at this point, bit 0 contains the parity of
	; (a,b,c,d,e,f,g,h).
;Need to: Compare the calculated parity with the actual parity recieved

	ENDIF
			; & fall through to echo char back 

Subroutine
Buf:RS232Out = SubEntryAddr
;Send byte via serial port (see UART ; )
;	bank    serial  (don't have to bank 'cause repeat does it for us)

	repeat			;wait for not busy 
	  while tx_count, IsNotZero

	not     temp		;ready bits (inverse logic) 
	mov     tx_high,temp	; store data byte 
	setb    tx_low.7	; set up start bit 
	mov     tx_count,#10	;1 start + 8 data + 1 stop bit 
	retp			;leave and fix page bits 
; 

Subroutine
Buf:Kbd = SubEntryAddr
;???

Subroutine
Buf:LCD = SubEntryAddr
;???

Subroutine
Buf:IRead = SubEntryAddr
	inc fsr
	mov m, ind
	dec fsr
	mov w, ind
	iread
	retp

Subroutine
Buf:IWrite = SubEntryAddr
	retp	;not possible on this chip.

Buf:FRead = MEM:Read

Buf:FWrite = MEM:Write


Subroutine
Buf:GetSrc = SubEntryAddr
;Get a byte from the source buffer
	DoIf PartMatchCount, IsNotZero
	 dec PartMatchCount
	 DoIf PartMatchCount, IsZero
	  and BufTyp, #~$07
	  bank BufSrcTypSav
	  mov w, BufSrcTypSav
	  bank BufTyp
	  or BufTyp, w
	  mmov BufSrcPtr, BufSrcPtrSav, 3
	  bank MatchCharSav
	  mov w, MatchCharSav
	  retp
	  DoEndIf
	 DoEndIf
	mov fsr, #BufSrcPtr
	mov w, BufTyp
	and w, #$07
;fall through to Buf:Get
Subroutine
Buf:Get = SubEntryAddr
;Get a byte from what ever buffer type is indexed by W
;entry:	W is expected to hold an index to the buffer type
;	fsr is expected to hold a pointer to the buffer address
;exit: 	W holds a byte removed from the end of that buffer.
	GotoW Buf:RRead, Buf:FRead, Buf:Host, Buf:Pop, Buf:IRead, Buf:RS232In, Buf:Kbd

;0	;00-8F RAM Registers
;1	;FLASH Memory (Mem:Read or Mem:Write)
;2	;Parallel Port (Peripheral (Perp) or Host)
;3	;Que (Push or Pop)
;4	;ROM (Program Memory IREAD or IWRITE if we had a bootloader)
;5	;Serial (RS232In or RS232Out)
;6	;Terminal 

Subroutine
Buf:PutDst = SubEntryAddr
;Put a byte from temp to the dst buffer
	mov fsr, #BufDstPtr
	mov w, BufTyp
	and w, #$70

Subroutine
Buf:Put = SubEntryAddr
;Put a byte to what ever buffer type is indexed by W
;entry:	W is expected to hold an index to the buffer type
;	fsr is expected to hold a pointer to the buffer address
;	temp is expected to hold a byte to send
;exit:	
	GotoW Buf:RWrite, Buf:FWrite, Buf:Perp, Buf:Push, Buf:IWrite, Buf:RS232Out, Buf:LCD


:Out
;

VPS ;Virtual Peripherals. Called at ISRRate by the Interrupt Service Routine

UART ;Universal Asynchronous Receiver Transmitter (UART) Virtual Peripheral-----
; This routine sends and receives RS232C serial data, and is currently 
; configured (though modifications can be made) for the popular 
; "No parity-checking, 8 data bit, 1 stop bit" (N,8,1) data format. 
; RECEIVING: The rx_flag is set high whenever a valid byte of data has been 
; received and it the calling routine's responsibility to reset this flag 
; once the incoming data has been collected. 
; TRANSMITTING: The transmit routine requires the data to be inverted 
; and loaded (tx_high+tx_low) register pair (with the inverted 8 data bits 
; stored in tx_high and tx_low bit 7 set high to act as a start bit). Then 
; the number of bits ready for transmission (10=1 start + 8 data + 1 stop) 
; must be loaded into the tx_count register. As soon as this latter is done, 
; the transmit routine immediately begins sending the data. 
; This routine has a varying execution rate and therefore should always be 
; placed after any timing-critical virtual peripherals such as timers, 
; adcs, pwms, etc. 
; Note: The transmit and receive routines are independent and either may be 
;	removed, if not needed, to reduce execution time and memory usage, 
;	as long as the initial "BANK serial" (common) instruction is kept. 
; 
;       Input variable(s) : tx_low (only high bit used), tx_high, tx_count 
;       Output variable(s) : rx_flag, rx_byte 
;       Variable(s) affected : tx_divide, rx_divide, rx_count 
;       Flag(s) affected : rx_flag 
;	Size : Transmit - 12 bytes + 1 byte shared with receive code 
;		Receive - 20 bytes + 1 byte shared with transmit code 
;       Timing (turbo) :  
;	       Transmit - (a) [not sending] 9 cycles 
;			  (b) [sending] 19 cycles 
;			  + 1 cycle shared with RX code ("bank" instr.) 
;		Receive - (a) [not receiving] 9 cycles 
;			  (b) [start receiving] 16 cycles 
;			  (c) [receiving, awaiting bit] 13 cycles 
;			  (d) [receiving, bit ready] 17 cycles 
; 


		bank    serial                  ;switch to serial register bank  

:transmit
	djnz tx_divide,:receive	;only do it every tx_divide ISRs
	mov tx_divide,#RS232ISRDiv
	test tx_count		;and not at all if we have no bits to send
	jz :receive		; maybe we are recieving
	clc			;shift in 0's for a stop bit at end of tx_count
	rr tx_high		;
	rr tx_low		;
;	movb RS232Tx, c		;copy the carry from the bottom of tx_low 
				;to the output pin
	mov w, RS232TxSpace
	sc
	mov w, RS232TxMark
	CtrlAssertExtW

:receive
	movb c,RS232Rx		;get current rx bit 
	test rx_count		;currently receiving byte? 
	jnz :rxbit		;if so, jump ahead 
	mov w,#9		;in case start, ready 9 bits 
	sc			;skip ahead if not start bit 
	mov rx_count,w		;it is, so renew bit count 
	mov w, #RS232StartDelay
	mov rx_divide,w		;ready 1.5 bit periods 
:rxbit
	djnz rx_divide,:Out	;middle of next bit? 
	mov w,#RS232ISRDiv	
	mov rx_divide,w		;yes, ready 1 bit period 
	dec rx_count		;last bit? 
	sz			;if not 
	rr      rx_byte		;  then save bit 
	jnz :Out		;if so 
	sc			; and if its a valid stop bit
	setb	RS232RxFrameErr	;  set error flag
	setb    RS232Rx_flag	;  then set flag 
:Out

ISRExternal

PPVP ; Centronix Printer Port Virtual Peripheral --------------------------------------
; Useing an ISR for the parallel port allows 1) background operation 2) instant 
; response to changes in port stats e.g. request from printer or PC.
;cycles: 7
;Step 0 - Data to be printed? may be, check it out.
;Step 1 - Switch drive of data port from Host to Plug
;Step 2 - Assert Data, Strobe on, Strobe off, Release data
;Step 3 - Wait for nAck (hope to sense via external interrupt)
;Step 4 - Wait for not Busy (hope to sense via external int)
;Step 8	- a do nothing which indicates that no data is waiting

	jmp @:Entry	
;just incase somebody is pointing to PPVP vs PPVP:Entry as they should.

:PPStep0 ;cycles:  			;Step 0 - Data to be printed? check it out.
	mov w, --PPBufTail		;Get the Tail - 1
IF CpuPins < 29
	setb	PPBufHead.4		;Cleanup Head in case we interrupted a data
					; write just after the inc PPBufHead
					;Let me do register operations on W (should always be)
;	mov !option, #myOpts & OptRTCisW
	setb Wreg.4			;Set the 4th bit in W (in case the "- 1" wrapped)
 ENDIF
	xor w, PPBufHead		;and compaire it with the Head
	jz @:PPStep0B			;Still have data to print? 
;perhaps we should check to see if the PCVP is recieving data and wait until either
;it is waiting (PCWaiting set) or its buffer is full (PCStep3 or PCBufTail = PCBufHead)
;so that the conversion from host drive to plug drive will occur only every 16th byte
	jb StatHBusy, @:PPStep1		; Is Prn Busy to Host Set? Continue to Step1
	CtrlAssert HostBusy		;  no? Assert Prn Busy to PC 
	jmp @:OutNext			;  and give the host time to see that
					;  Next: Step 1. (next step is default)

:PPStep0B				;No more data is waiting
	setb	PPBufEmpty		;Make a note of that (This sets us to Step 8)
	mov	w, PCBufTail		;see if there is any room
	xor	w, PCBufHead		; left in the Host buffer
	jz	@:Out			;If we have room for data from the Host,
	jnb	StatHBusy,@:Out		; and we haven't already,
	mov	!PDataPort,#$FF		;  stop driving the data port, (shouldn't be anyway)
	CtrlAssert HostDataDrive	;  let the host drive it,
	CtrlAssert HostReady		;  and let the Host know by releaseing HBusy,
	jmp 	@:Out			;  then just go dormant. Next: Step 8.

:PPStep1				;Step 1 - Switch drive of data port from Host to Plug
	setb	PPNext.0
:PPStep1a
; break
	jb	Stat_245nOE,@:PPStep2
					;Are we already driving the data port? Step2
	CtrlAssert HostDataRelease	; no? Stop passing host data to the port.
	jmp	@:OutNext		;  and give it time to settle
					;  Next: Step 2. (next step is default)

:PPStep2				;Step 2 - strobe out the data
	setb	PPNext.1		;Make sure we are on step two
	clrb	PPNext.0
:PPStep2i				;Step 2a - Assert data for at least 0.5us 
	mov	w, --PPBufTail
	mov	fsr, w			; OutPut next byte
IF CpuPins < 29
	setb	fsr.4
 ENDIF
	mov	PDataPort,ind ;thru w
:PPStep2a				; The step is complete at this point
	Port PDataPort,out,$FF		; Assert data lines,
	bank	PPVPmem			; fix the bank
;	delay 500 - (CpuMhz / (:PPStep2b - :PPStep2a)), nsec
	mov	w,#(500-(CpuMhz/(:PPStep2b-:PPStep2a)))/100	
	page $+1
	djnz	1, $			; 9 cycles down 16 to go ~= 4*4=16

;Step 2b - Strobe the data out to printer
	CtrlAssert DataPStrobe		; Assert Strobe for Data, 
:PPStep2b				; The step is complete at this point
;	delay 500-(CpuMhz/(:PPStep2c-:PPStep2b)), nsec
	mov	w,#(500-(CpuMhz/(:PPStep2c-:PPStep2b)))/100	;0.5us min
	page $+1
	djnz	1, $			; 7 cycles down 18 to go ~= 5*4=20

;Step 2c - Release the strobe
	CtrlAssert HostDataRelease	; Release Strobe, keep data 0.5us min
:PPStep2c				; The step is complete at this point
	mov	m,#WKPND_B	;clear/check pending external interrupts
	clr	w				
	mov	!rb,w		;with rb only, mov exchanges data, w = pending
	and	w,#~rbIntMask
	or	StatusFlags, w	;flag any changes in the status lines.
;ready to wait for change in Busy or NAck
;	delay 500-(CpuMhz/(:PPStep2d-:PPStep2c)), nsec
	mov	w,#(500-(CpuMhz/(:PPStep2d-:PPStep2c))/100)	; 11 cycles down 14 to go ~= 4*4=16
	page $+1
	djnz	1, $

:PPStep2d					;Step 2d - Release the data lines
	Port PDataPort,in,$FF		; Release data lines, 
	;later...			; Set Timeout to 5ms, 2083 ISRs
;	mov	w,TimerAccH
;	add	w,8		;8*614.401us = 6.51ms +- 0.614
;	mov	PPTimeOut, w
;	jmp	@:OutNext
	inc	PPNext

:PPStep3					;Step 3 - Wait for NAck
	jb	PnAckFlag,@:PPStep3b	; No PnAckFlag? 
;	csbe	TimerAccH,PPTimeOut	;  Timeout? 
;	and	PPNext,#$F0		;   Next: Step 0 (try again)
	jmp	@:Out			;  else Next: Step 6 (repeat)
:PPStep3b				; PnAckFlag!
	clrb	PnAckFlag		;  Clear PnAckFlag
		;later...			;  Set Timeout to 5s, 2083333 ISRs
;	mov	w,TimerAccT
;	add	w,32			;32*0.157286s = 5.03315s +- 0.157286
;	mov	PPTimeOut, w
	DecBufPtr PPBufTail		; Let go of the data
	jmp	@:OutNext		;  Next: Step 7

:PPStep4
:PPStep4a					;Step 4 - Wait for printer not Busy
	jnb	PBusy, :PPStep4b	; PBusy? 
;	csbe	TimerAccT,@:TimeOut	;  Timeout?
;	and	PPNext, #$F0		;   Try again
	jmp	@:Out			;   Next: Step 7 (repeat)
	
:PPStep4b					; No? Not PBusy!
	and	PPNext, #$F0		;  Ready to do the next byte
	jmp	@:Out			;  Next: Step 0

:Entry
; break
	bank	PPVPMem
	jb	PPBufEmpty,@:PPStep8	;acutally PPNext bit 3.
	mov	m,#TRIS
	mov	w,PPNext
	and	w,#$07
	GotoW PPVP:PPStep0, PPVP:PPStep1a, PPVP:PPStep2i, PPVP:PPStep3, PPVP:PPStep4

:OutNext
	inc	PPNext			;by default, move to the next step

:PPStep8	;a do nothing which indicates that no data is waiting
	bank	PPVPmem

:Out

PCVP ;IBM PC Parallel Port Virtual Peripheral ---------------------------------------
; Reads PC parallel port and responds or passes on to Printer Port Virtual Peripheral
:Entry
; break
	bank PCVPmem
	jnb HnStrobeFlag,@:Steps	;if the strobe may have brought us here
	clrb	HnStrobeFlag		; clear it
	jnb PCWaiting,@:Out		; and exit if we were not waiting for data

:GotStrobe
;I just got strobed by the Host. It has data ready and would not have strobed me if
;I was asserting Busy and I had better have been asserting Busy if I wasn't letting
;host data past the '245 bi-di buffers gate onto the PDataPort, and that data was 
;prestored at the start of the ISR to ISRData, so... we already have the data.

	CtrlAssert HostBusy	;Hold on while we take care of this.
	and	PCNext,#$0F	;Continue with step 0
	mov	w, PCBufHead
	mov	fsr, w
	bank	PCVPMem		;in bank 0 col on the same row as tail
	mov	w, ISRData
	bank	PCBuf
	mov	ind, w
	bank	PCVPMem
	DecBufPtr PCBufHead

;	push	TimerAccL

	bank	PCVPMem
	jmp	@:Out

:PCStep0	;Just asserted Busy, wait for HnStrobe release
	jnb	HnStrobe,@:Out
	jmp	@:OutNext 
;don't nAck immediatly so that the host has time (2.4us) to see the Busy

:PCStep1	;Assert nAck
	CtrlAssert HostAckBusy
	jmp	@:OutNext
;give the host another 2.4us to see the nAck

:PCStep2	;Release nAck. Release Busy unless full
	CtrlAssert HostBusy	;Let nAck go, but keep Busy.
	add 	PCNext, #$10	;Next is Step3 (or Step4)

:PCStep3	;Out of room for data, wait for space to store data.
	mov	w, PCBufTail	;see if there is any room
	xor	w, PCBufHead	; left in the buffer
	jz	@:Out		;Nope, still full.
					
:NotFull
	jnb	PPBufEmpty,@:Out	;If we aren't sending data to the Periph
	add 	PCNext, #$10	;go back to step 4
	clrb	HnStrobeFlag	;clear any extranious strobes
	CtrlAssert HostReady	;drop busy and be ready for the next byte.
	jmp	@:Out
;host has to give us 0.5us before nStrobe so we can do 25 cycles before the next one

;Step 3 has been merged into Step 2 above...
;:PCStep3	;Out of room for data, wait for space to store data.
;HBusy got set when we got strobed with the last byte of data that we did have room for
;so we just need to loop here and check for space to get free...
;	mov	w, PCBufTail
;	xor	w, PCBufHead
;	jz	@:Out		;still full.
;	jmp 	@:NotFull

:PCStep4	= ISR:Out	;waiting for next data
	;only GotStrobe moves us to Step1


:Steps
;Ok, it wasn't a strobe so we must be here on a timed basis
	jb	PCWaiting, @:Out	;quick out when just waiting for data
	mov	w,<>PPNext
	and	w,#$0F
; break
;Step0	;Just asserted Busy, wait for HnStrobe release
;Step1	;Assert nAck
;Step2	;Release nAck. Release Busy unless full
;Step3	;Out of room for data, wait for space to store data.
;Step4	;waiting for next data (bit 6 of PPNext aka PCWaiting will be set)
	GotoW :PCStep0, :PCStep1, :PCStep2, :PCStep3


:OutNext
	add	PCNext,#$10			;by default, move to the next step

:Out	=	ISR:Out	
;this little optimization short circuits any jumps to @PCVP:Out to @ISR:Out

;End of the Virtual Peripherals
	JMP	@ISR:Out

SETUP ;***************************************************************************
; IO PORTS -----------------------------------------------------------------------
	bank 0

;mode (m) defaults to $0F or $1F - !r{a,b,c} is the data direction register
;ports default to input, no pullup, ttl, no schmidtt on all pins
IF CPUPins > 28
;   SX52 Port setup
;  
	PortMode TRIS
	mov	!ControlPort, #ControlPortDir
IF RS232Gnd = RS232Tx
	mov	w, #(1<<(MemSpiNCS/$100))
ELSE
	mov	w, #(1<<(MemSpiNCS/$100)) | (1<<(RS232Gnd/$100))
ENDIF
	mov	MemSpiPortImg, w
	mov	MemSpiPort, w
	mov	!MemSpiPort, #MemSpiPortDir

ELSE
;   SX28 Port setup
;  
	clr	PDataPort
	Port PDataPort, in, $FF	;set RC to all input

	clr	StatusPort
	Port StatusPort, in, StatusPortDir
	Port StatusPort, sch, $FF	

	clr	CtrlPort
	Port CtrlPort, in, CtrlPortDir

IF DebugMemSpi>2
	port	DebugPort, out, $FF
ENDIF
ENDIF

:PPPort ;Setup -----------------------------------------------------------
	CtrlAssert HostDataDrive	; Let the host have the port
;later, we will want to take the port so we can download our data to printer RAM
	CtrlAssert HostBusy		; Host.Busy On
:PPPortDone
	setb CtrlnE	
;necessary so that changes made in the ISR will not be overwritten
;by a previous opposite value on that same control line.
;Really, only the ISR should be messing with the centronix controls.

:PCPort ;Setup ----------------------------------------------------------

:PCPortDone
	setb CtrlnE	
;necessary so that changes made in the ISR will not be overwritten
;by a previous opposite value on that same control line.
;Really, only the ISR should be messing with the centronix controls.

; RAM - reset all ram banks
; GLOBAL RAM ---------------------------------------------------------------------
	mov	fsr,#GPRegOrg
:gloop
	clr	ind		;set register pointed to by fsr to zero
	inc	fsr
	sb	fsr.4
	jmp	@:gloop	;until fsr rolls over from $0F

; RAM BANKS ----------------------------------------------------------------------
:loop
IF CpuPins <= 28
	setb	fsr.4		;avoid control registers on smaller chips
ENDIF
	clr	ind		;set register pointed to by fsr to zero
	ijnz	fsr,@:loop	;until fsr rolls over from $FF

; Printer Port Virtual Peripheral ------------------------------------------------
	bank	PPNext
	clr	PPNext

; PPBuffer ----------------------------------------------------------------------
	bank	PPVPMem
	mov	w,#PPBuf + $0F
	mov	PPBufTail,w
	mov	PPBufHead,w
	dec	PPBufHead
	setb	PPBufEmpty

; PCBuffer ----------------------------------------------------------------------
	bank	PCVPMem
	mov	w,#PCBuf + $0F
	mov	PCBufTail,w
	mov	PCBufHead,w
	dec	PCBufHead
	setb	PCWaiting


; Stack ------------------------------------------------------------------------
	bank	StackPtr
	mov	StackPtr, #Stack+15

:PortBISR ;Setup ---------------------------------------------------------------
;configure the wakeup interrupt

	Port StatusPort, intedge, rbIntEdge

	PortMode WKPND_B	;clear WKPND_B (Int Service Pending)
	clr	w
	mov	!rb,w

	Port StatusPort, inten, rbIntMask

	PortMode TRIS
	clr	PnAckFlag	;clear the Ack flag

:TimerISR ;Setup ----------------------------------------------------------
	mov	rtcc,#$10
	mov	!option,#myOpts	;enable rtcc interrupt



MAIN ;PROGRAM ********************************************************************

IF DebugMemSpi>2 AND DebugPC < 2 AND DebugPP < 2
	watch NextChar,8,uhex
		bank	0
;Write a pattern to the buffer
		clr	DebugPort
		setb	DebugPort.5	;keep it in ASCII printable
		clrb	MemOpWait
		mov	fsr, #MemBuf1PgHi
		bank	MemSpi
		mov	MemBufPgAdr,#0
		bank	NextChar
		mov	NextChar,#0
MAINLOOP
repeat
		bank 	NextChar
		mov	w,NextChar
		bank 	MemSpi
		inc	MemBufPgAdr
		mov	MemBufData, w
		call	@MEM:BufWrite
		until	MemBufPgAdr, iszero

;Make sure the pattern is in the buffer
		bank	MemSpi
		clr	MemBufPgAdr
repeat
		bank 	NextChar
		mov	w,NextChar
		bank 	MemSpi
		inc	MemBufPgAdr
		mov	MemBufData, w
		call	@MEM:BufRead
		bank 	NextChar
		stc
		mov	w, NextChar - w
		sz
		setb	ErrBufReadBack
		until	MemBufPgAdr, iszero
;Write the buffer to a page
		call	@Mem:PgWrite
;point to the next page
		bank	MemSpi
;	break
		inc	MemBufPgLo
;repeat untill all (256) pages have been written with this pattern (NextChar)
		jnz	@MAINLOOP

;now read each page back in
		call	@Mem:PgRead
;and check each page for the pattern
repeat
		bank 	NextChar
		mov	w,NextChar
		bank 	MemSpi
		inc	MemBufPgAdr
		call	@MEM:BufRead
		bank 	NextChar
		stc
		mov	w, NextChar - w
		sz
		setb	ErrPgReadBack
		until	MemBufPgAdr, iszero

		bank	NextChar
;		and	rc,#~1<<(ErrLoopDone/$100)
		xor	DebugPort,#1<<(ErrLoopDone/$100)
 IF DebugPP > 0
		mov w, DebugPort
		Call @Buf:Perf
		clrb	ErrBufReadBack
		clrb	ErrPgReadBack
  ENDIF
		inc	NextChar
;Then do it all again with a new pattern
		jmp	@MAINLOOP
 ENDIF

IF DebugPP > 0 AND DebugPC < 2
	mov	NextChar,#testdata:print//256	; low
 IF DebugMemSpi < 1
	Repeat
	 bank	NextChar
	 mov	m, #(testdata:print/$100)	; high
	 mov	w, NextChar
	 inc	NextChar
	 iread	
	 DoIf wReg,IsNotZero
	  call	@Buf:Perp
	  Forever
	  DoEndIf
:done
 ELSE ;Debugging PP and MemSpi but not PC. UNTESTED
	clrb	MemOpWait
	mov	fsr, #MemBuf1PgHi
	bank	MemSpi
	mov	MemBufPgAdr,#0
	bank	NextChar
	mov	NextChar,#0
	Repeat
	 bank	NextChar
	 mov	m, #(testdata:print/$100)	; high
	 mov	w, NextChar
	 inc	NextChar
	 iread	
	 bank 	MemSpi
	 inc	MemBufPgAdr
	 mov	MemBufData, w
	 call	@MEM:BufWrite
	 While	MemBufData,IsNotZero
	clr	MemBufPgAdr
	repeat
	 bank 	NextChar
	 mov	w,NextChar
	 bank 	MemSpi
	 inc	MemBufPgAdr
	 mov	MemBufData, w
	 call	@MEM:BufRead
	 call	@Buf:Perp
	 While	MemBufData,IsNotZero
  ENDIF
 ENDIF

IF DebugPC > 0
	CtrlAssert HostReady
	setb CtrlnE	
;necessary so that changes made in the ISR will not be overwritten
;by a previous opposite value on that same control line.
;Really, only the ISR should be messing with the centronix controls.

 ENDIF

IF DebugVM > 1
	bank	NextChar
	mov NextChar, #((testdata:stream)//$100)
	Repeat
	 bank	PCVPMem
	 mov	w, PCBufHead
	 mov	fsr, w
	 bank	NextChar
	 mov	m, #((testdata:stream)/$100)	; high
	 mov	w, NextChar
	 inc	NextChar
	 iread	
	 bank	PCBuf
	 mov	ind, w
	 bank	PCVPMem
	 DecBufPtr PCBufHead
	 bank NextChar
	 mov w, NextChar
	 xor w, #((testdata:stream)//$100)+15
	 WhileNotZero
 ENDIF

	bank VMMem
	mov TokIPPtr+2, #0
	mov TokIPPtr+1, #(testdata:boot >> 8)
	mov TokIPPtr+0, #(testdata:boot & $FF)
	mov TokIpTyp, #BufTypR
	VMNext

TokTry	MACRO
; expand
 dw ';'
; noexpand
StackTOS = $
StackPUSH
	org $+1
  IF \0 > 0
    REPT \0
; expand
	dw \%
; noexpand
      ENDR
   ENDIF
 ENDM

TokRet MACRO
TokTryOut = $
  StackPOP
; expand
	org StackTOS
	dw (TokTryOut) & $FF
; noexpand
	org TokTryOut
 ENDM

TokTxt MACRO
; expand
 dw '"'
; noexpand
TokTxtAdr = $
	org $+1
	REPT \0
; expand
	dw \%
; noexpand
	ENDR
TokTxtOut = $
; expand
	org TokTxtAdr
	dw ((TokTxtOut - TokTxtAdr) -1) & $FF
; noexpand
	org TokTxtOut
	ENDM

TokRep MACRO 0
 dw '('
 ENDM

TokWhile MACRO 0
 dw ')'
 ENDM


testdata
IF DebugVM > 1
:stream
;	dw $1b,'@PJL SET RESOLUTION="300"',$0A
	dw $1b,'@PJL',$1B,'BEGIN',$1B,'END'
 ENDIF
	org $700
:boot
;	;checksum first sector of FLASH
;	dw '@80+,\@F1!'
;	;if ok start executing tokens from the first sector
;	TokTry	 '@80=@F0?@F1:'
;	  TokRet
;	;passthrough from host to peripheral look for trigger to start writing new boot code to flash.
       TokRep
	TokRep
	 dw '@P'
	 TokTry	
	  TokTxt $1B,'BEGIN'
	  dw '@F1'
	  TokRep
	   TokTry 
	    TokTxt $1B,'END'
	    dw '?@F0!'
	    TokRet
	   dw '!'
	   TokWhile
	  dw '?@P'
	  TokTxt 'EFORMS LOADED'
	  TokRet
	 TokTry	
;	  TokTxt $1B,'@PJL SET RESOLUTION="300"'
	  TokTxt $1B,'@PJL'
	  dw '?'
	  TokRet
	 TokTry '?@P!'
	  TokRet
	 TokWhile
	TokWhile


IF DebugPP > 0 AND DebugPC < 2
:print
	dw	$1b,'&f10y0XMacro 10',$1b,'&f1x10x2X'
	dw	$0C	;
	dw	$00

 ENDIF
	end

